(* ----------------------------------------------------------------------------- *) 
(* This model file was automatically created by SARAH version4.6.0  *) 
(* SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223 *) 
(* (c) Florian Staub, 2013  *) 
(* ----------------------------------------------------------------------------- *) 
(* File created at 12:29 on 18.11.2015  *) 
(* ---------------------------------------------------------------------- *) 
 
 
IndexRange[  Index[Colour]  ] =NoUnfold[Range[3]]; 
IndexStyle[  Index[Colour, i_Integer ] ] := Greek[i];  
IndexRange[  Index[I2Gen]  ] =Range[2]; 
IndexStyle[  Index[I2Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[I3Gen]  ] =Range[3]; 
IndexStyle[  Index[I3Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[I6Gen]  ] =Range[6]; 
IndexStyle[  Index[I6Gen, i_Integer ] ] := Alph[ 8+i];  
IndexRange[  Index[Gluon]  ] =NoUnfold[Range[8]]; 
IndexStyle[  Index[Gluon, i_Integer ] ] := Alph[ 8+i];  

 
(* Definitions for trigonometric functions  
Sin[ThetaW]: STW
Sin[2*ThetaW]: S2TW
Sin[ThetaWp]: STWp
Sin[2*ThetaWp]: S2TWp
Cos[ThetaW]: CTW
Cos[ThetaWp]: CTWp
*) 
 
Conjugate[STW] ^= STW
Conjugate[S2TW] ^= S2TW
Conjugate[STWp] ^= STWp
Conjugate[S2TWp] ^= S2TWp
Conjugate[CTW] ^= CTW
Conjugate[CTWp] ^= CTWp
 
 
Lam[a_,b_,c_]:=2*SUNT[a,b,c]; 
fSU3[a_,b_,c_]:=SUNF[a,b,c]; 
LambdaProd[a_,b_][c_,d_]:=4*SUNT[a,b,c,d]; 
 
 
M$ClassesDescription= {
S[3] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassHm,
PropagatorLabel->ComposedChar["H","-"],
PropagatorType -> ScalarDash,
PropagatorArrow -> Forward},

 
S[1] == {SelfConjugate -> True,
Indices -> {Index[I2Gen]},
Mass -> Masshh,
PropagatorLabel->ComposedChar["h",Index[I2Gen]],
PropagatorType -> ScalarDash,
PropagatorArrow -> None},

 
S[2] == {SelfConjugate -> True,
Indices -> {Index[I2Gen]},
Mass -> MassAh,
PropagatorLabel->ComposedChar["A",Index[I2Gen],"h"],
PropagatorType -> ScalarDash,
PropagatorArrow -> None},

 
F[4] == {SelfConjugate -> False,
Indices -> {Index[I3Gen], Index[Colour]},
Mass -> MassFd,
PropagatorLabel->ComposedChar["d",Index[I3Gen],Index[Colour]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[3] == {SelfConjugate -> False,
Indices -> {Index[I3Gen], Index[Colour]},
Mass -> MassFu,
PropagatorLabel->ComposedChar["u",Index[I3Gen],Index[Colour]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[2] == {SelfConjugate -> False,
Indices -> {Index[I3Gen]},
Mass -> MassFe,
PropagatorLabel->ComposedChar["e",Index[I3Gen]],
PropagatorType -> Straight,
PropagatorArrow -> Forward},

 
F[1] == {SelfConjugate -> True,
Indices -> {Index[I6Gen]},
Mass -> MassFv,
PropagatorLabel->ComposedChar["\\nu",Index[I6Gen]],
PropagatorType -> Straight,
PropagatorArrow -> None},

 
V[5] == {SelfConjugate -> True,
Indices -> {Index[Gluon]},
Mass -> 0,
PropagatorLabel->ComposedChar["g",Index[Gluon]],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[1] == {SelfConjugate -> True,
Indices -> {},
Mass -> 0,
PropagatorLabel->ComposedChar["\\gamma"],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[2] == {SelfConjugate -> True,
Indices -> {},
Mass -> MassVZ,
PropagatorLabel->ComposedChar["Z"],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[10] == {SelfConjugate -> True,
Indices -> {},
Mass -> MassVZp,
PropagatorLabel->ComposedChar["Z'"],
PropagatorType -> Sine,
PropagatorArrow -> None},

 
V[3] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["W","-"],
PropagatorType -> Sine,
PropagatorArrow -> Forward},

 
U[5] == {SelfConjugate -> False,
Indices -> {Index[Gluon]},
Mass -> 0,
PropagatorLabel->ComposedChar["\\eta",Index[Gluon],"G"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[1] == {SelfConjugate -> False,
Indices -> {},
Mass -> 0,
PropagatorLabel->ComposedChar["\\eta","\\gamma"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[2] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVZ,
PropagatorLabel->ComposedChar["\\eta","Z"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[10] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVZp,
PropagatorLabel->ComposedChar["\\eta","Z'"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[3] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["\\eta","-"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward},

 
U[4] == {SelfConjugate -> False,
Indices -> {},
Mass -> MassVWm,
PropagatorLabel->ComposedChar["\\eta","+"],
PropagatorType -> GhostDash,
PropagatorArrow -> Forward}
 
}

 
MassFd[gen_, y_] = MassFd[gen]
MassFu[gen_, y_] = MassFu[gen]


GaugeXi[S[3,{a_Integer}]] = 1 /; a > 1 
GaugeXi[S[3,1]] = GaugeXi[VWm] /; a > 1 
GaugeXi[S[1,___]] = 1 
GaugeXi[S[2,{a_Integer}]] = 1 /; a > 1 
GaugeXi[S[2,1]] = GaugeXi[VZ] /; a > 1 


GaugeXi[V[5,___]] = GaugeXi[G]
GaugeXi[V[1,___]] = GaugeXi[P]
GaugeXi[V[2,___]] = GaugeXi[Z]
GaugeXi[V[10,___]] = GaugeXi[Zp]
GaugeXi[V[3,___]] = GaugeXi[Wm]


M$CouplingMatrices= {
C[V[5, {ct1}], V[5, {ct2}], V[5, {ct3}], V[5, {ct4}]] == {{(-I)*g3^2*(fSU3[1, ct1, ct4]*fSU3[1, ct2, ct3] + fSU3[1, ct1, ct3]*fSU3[1, ct2, ct4] + fSU3[2, ct1, ct4]*fSU3[2, ct2, ct3] + fSU3[2, ct1, ct3]*fSU3[2, ct2, ct4] + fSU3[3, ct1, ct4]*fSU3[3, ct2, ct3] + fSU3[3, ct1, ct3]*fSU3[3, ct2, ct4] + fSU3[4, ct1, ct4]*fSU3[4, ct2, ct3] + fSU3[4, ct1, ct3]*fSU3[4, ct2, ct4] + fSU3[5, ct1, ct4]*fSU3[5, ct2, ct3] + fSU3[5, ct1, ct3]*fSU3[5, ct2, ct4] + fSU3[6, ct1, ct4]*fSU3[6, ct2, ct3] + fSU3[6, ct1, ct3]*fSU3[6, ct2, ct4] + fSU3[7, ct1, ct4]*fSU3[7, ct2, ct3] + fSU3[7, ct1, ct3]*fSU3[7, ct2, ct4] + fSU3[8, ct1, ct4]*fSU3[8, ct2, ct3] + fSU3[8, ct1, ct3]*fSU3[8, ct2, ct4])}, {I*g3^2*(fSU3[1, ct1, ct4]*fSU3[1, ct2, ct3] - fSU3[1, ct1, ct2]*fSU3[1, ct3, ct4] + fSU3[2, ct1, ct4]*fSU3[2, ct2, ct3] - fSU3[2, ct1, ct2]*fSU3[2, ct3, ct4] + fSU3[3, ct1, ct4]*fSU3[3, ct2, ct3] - fSU3[3, ct1, ct2]*fSU3[3, ct3, ct4] + fSU3[4, ct1, ct4]*fSU3[4, ct2, ct3] - fSU3[4, ct1, ct2]*fSU3[4, ct3, ct4] + fSU3[5, ct1, ct4]*fSU3[5, ct2, ct3] - fSU3[5, ct1, ct2]*fSU3[5, ct3, ct4] + fSU3[6, ct1, ct4]*fSU3[6, ct2, ct3] - fSU3[6, ct1, ct2]*fSU3[6, ct3, ct4] + fSU3[7, ct1, ct4]*fSU3[7, ct2, ct3] - fSU3[7, ct1, ct2]*fSU3[7, ct3, ct4] + fSU3[8, ct1, ct4]*fSU3[8, ct2, ct3] - fSU3[8, ct1, ct2]*fSU3[8, ct3, ct4])}, {I*g3^2*(fSU3[1, ct1, ct3]*fSU3[1, ct2, ct4] + fSU3[1, ct1, ct2]*fSU3[1, ct3, ct4] + fSU3[2, ct1, ct3]*fSU3[2, ct2, ct4] + fSU3[2, ct1, ct2]*fSU3[2, ct3, ct4] + fSU3[3, ct1, ct3]*fSU3[3, ct2, ct4] + fSU3[3, ct1, ct2]*fSU3[3, ct3, ct4] + fSU3[4, ct1, ct3]*fSU3[4, ct2, ct4] + fSU3[4, ct1, ct2]*fSU3[4, ct3, ct4] + fSU3[5, ct1, ct3]*fSU3[5, ct2, ct4] + fSU3[5, ct1, ct2]*fSU3[5, ct3, ct4] + fSU3[6, ct1, ct3]*fSU3[6, ct2, ct4] + fSU3[6, ct1, ct2]*fSU3[6, ct3, ct4] + fSU3[7, ct1, ct3]*fSU3[7, ct2, ct4] + fSU3[7, ct1, ct2]*fSU3[7, ct3, ct4] + fSU3[8, ct1, ct3]*fSU3[8, ct2, ct4] + fSU3[8, ct1, ct2]*fSU3[8, ct3, ct4])}},
 C[-V[3], V[1], V[1], V[3]] == {{I*g2^2*STW^2}, {I*g2^2*STW^2}, {(-2*I)*g2^2*STW^2}},
 C[-V[3], V[1], V[3], V[2]] == {{I*CTW*CTWp*g2^2*STW}, {(-I)*CTWp*g2^2*S2TW}, {I*CTW*CTWp*g2^2*STW}},
 C[-V[3], V[1], V[3], V[10]] == {{(-I)*CTW*g2^2*STW*STWp}, {I*g2^2*S2TW*STWp}, {(-I)*CTW*g2^2*STW*STWp}},
 C[-V[3], -V[3], V[3], V[3]] == {{(2*I)*g2^2}, {(-I)*g2^2}, {(-I)*g2^2}},
 C[-V[3], V[3], V[2], V[2]] == {{(-2*I)*CTW^2*CTWp^2*g2^2}, {I*CTW^2*CTWp^2*g2^2}, {I*CTW^2*CTWp^2*g2^2}},
 C[-V[3], V[3], V[2], V[10]] == {{I*CTW^2*g2^2*S2TWp}, {(-I)*CTW^2*CTWp*g2^2*STWp}, {(-I)*CTW^2*CTWp*g2^2*STWp}},
 C[-V[3], V[3], V[10], V[10]] == {{(-2*I)*CTW^2*g2^2*STWp^2}, {I*CTW^2*g2^2*STWp^2}, {I*CTW^2*g2^2*STWp^2}},
 C[S[2, {gt1}], S[2, {gt2}], V[1], V[1]] == {{(I/2)*((CTW*g1 - g2*STW)^2*ZA[gt1, 1]*ZA[gt2, 1] + 16*CTW^2*gYB^2*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[2, {gt2}], V[1], V[2]] == {{(-I/2)*((CTW*g1 - g2*STW)*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*ZA[gt1, 1]*ZA[gt2, 1] + 8*gYB*(CTWp*gYB*S2TW - 2*CTW*gBL*STWp)*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[2, {gt2}], V[1], V[10]] == {{(I/2)*((CTW*g1 - g2*STW)*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*ZA[gt1, 1]*ZA[gt2, 1] + 8*gYB*(2*CTW*CTWp*gBL + gYB*S2TW*STWp)*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[2, {gt2}], -V[3], V[3]] == {{(I/2)*g2^2*ZA[gt1, 1]*ZA[gt2, 1]}},
 C[S[2, {gt1}], S[2, {gt2}], V[2], V[2]] == {{(I/2)*((CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)^2*ZA[gt1, 1]*ZA[gt2, 1] + 16*(CTWp*gYB*STW - gBL*STWp)^2*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[2, {gt2}], V[2], V[10]] == {{(-I/2)*((CTWp^2*g1*gBY*STW + CTW^2*CTWp*g2^2*STWp + CTWp*(-gBY^2 + g1^2*STW^2)*STWp - g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))*ZA[gt1, 1]*ZA[gt2, 1] + 8*(-(gBL^2*S2TWp) + 2*CTWp^2*gBL*gYB*STW + gYB^2*S2TWp*STW^2 - 2*gBL*gYB*STW*STWp^2)*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[2, {gt2}], V[10], V[10]] == {{(I/2)*((CTWp*gBY + (CTW*g2 + g1*STW)*STWp)^2*ZA[gt1, 1]*ZA[gt2, 1] + 16*(CTWp*gBL + gYB*STW*STWp)^2*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[2, {gt1}], S[3], -V[3], V[1]] == {{-(CTW*g1*g2*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], S[3], -V[3], V[2]] == {{(g2*(CTWp*g1*STW - gBY*STWp)*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], S[3], -V[3], V[10]] == {{-(g2*(CTWp*gBY + g1*STW*STWp)*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], -S[3], V[1], V[3]] == {{(CTW*g1*g2*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], -S[3], V[3], V[2]] == {{(g2*(-(CTWp*g1*STW) + gBY*STWp)*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], -S[3], V[3], V[10]] == {{(g2*(CTWp*gBY + g1*STW*STWp)*ZA[gt1, 1])/2}},
 C[S[1, {gt1}], S[1, {gt2}], V[1], V[1]] == {{(I/2)*((CTW*g1 - g2*STW)^2*ZH[gt1, 1]*ZH[gt2, 1] + 16*CTW^2*gYB^2*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], V[1], V[2]] == {{(-I/2)*((CTW*g1 - g2*STW)*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*ZH[gt1, 1]*ZH[gt2, 1] + 8*gYB*(CTWp*gYB*S2TW - 2*CTW*gBL*STWp)*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], V[1], V[10]] == {{(I/2)*((CTW*g1 - g2*STW)*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*ZH[gt1, 1]*ZH[gt2, 1] + 8*gYB*(2*CTW*CTWp*gBL + gYB*S2TW*STWp)*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], -V[3], V[3]] == {{(I/2)*g2^2*ZH[gt1, 1]*ZH[gt2, 1]}},
 C[S[1, {gt1}], S[1, {gt2}], V[2], V[2]] == {{(I/2)*((CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)^2*ZH[gt1, 1]*ZH[gt2, 1] + 16*(CTWp*gYB*STW - gBL*STWp)^2*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], V[2], V[10]] == {{(-I/2)*((CTWp^2*g1*gBY*STW + CTW^2*CTWp*g2^2*STWp + CTWp*(-gBY^2 + g1^2*STW^2)*STWp - g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))*ZH[gt1, 1]*ZH[gt2, 1] + 8*(-(gBL^2*S2TWp) + 2*CTWp^2*gBL*gYB*STW + gYB^2*S2TWp*STW^2 - 2*gBL*gYB*STW*STWp^2)*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], V[10], V[10]] == {{(I/2)*((CTWp*gBY + (CTW*g2 + g1*STW)*STWp)^2*ZH[gt1, 1]*ZH[gt2, 1] + 16*(CTWp*gBL + gYB*STW*STWp)^2*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[1, {gt1}], S[3], -V[3], V[1]] == {{(-I/2)*CTW*g1*g2*ZH[gt1, 1]}},
 C[S[1, {gt1}], S[3], -V[3], V[2]] == {{(I/2)*g2*(CTWp*g1*STW - gBY*STWp)*ZH[gt1, 1]}},
 C[S[1, {gt1}], S[3], -V[3], V[10]] == {{(-I/2)*g2*(CTWp*gBY + g1*STW*STWp)*ZH[gt1, 1]}},
 C[S[1, {gt1}], -S[3], V[1], V[3]] == {{(-I/2)*CTW*g1*g2*ZH[gt1, 1]}},
 C[S[1, {gt1}], -S[3], V[3], V[2]] == {{(I/2)*g2*(CTWp*g1*STW - gBY*STWp)*ZH[gt1, 1]}},
 C[S[1, {gt1}], -S[3], V[3], V[10]] == {{(-I/2)*g2*(CTWp*gBY + g1*STW*STWp)*ZH[gt1, 1]}},
 C[S[3], -S[3], V[1], V[1]] == {{(I/2)*(CTW*g1 + g2*STW)^2}},
 C[S[3], -S[3], V[1], V[2]] == {{(I/2)*(CTW*g1 + g2*STW)*(CTW*CTWp*g2 - CTWp*g1*STW + gBY*STWp)}},
 C[S[3], -S[3], V[1], V[10]] == {{(I/2)*(CTW*g1 + g2*STW)*(CTWp*gBY + (-(CTW*g2) + g1*STW)*STWp)}},
 C[S[3], -S[3], -V[3], V[3]] == {{(I/2)*g2^2}},
 C[S[3], -S[3], V[2], V[2]] == {{(I/2)*(CTW*CTWp*g2 - CTWp*g1*STW + gBY*STWp)^2}},
 C[S[3], -S[3], V[2], V[10]] == {{(I/2)*(-(CTWp^2*g1*gBY*STW) - CTW^2*CTWp*g2^2*STWp + CTWp*(gBY^2 - g1^2*STW^2)*STWp + g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))}},
 C[S[3], -S[3], V[10], V[10]] == {{(I/2)*(CTWp*gBY + (-(CTW*g2) + g1*STW)*STWp)^2}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], S[2, {gt3}]] == {{(IndexDelta[ct1, ct2]*(Conjugate[ZDL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 1] + Conjugate[ZDR[gt1, 2]]*Yd[2, 1] + Conjugate[ZDR[gt1, 3]]*Yd[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 2] + Conjugate[ZDR[gt1, 2]]*Yd[2, 2] + Conjugate[ZDR[gt1, 3]]*Yd[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 3] + Conjugate[ZDR[gt1, 2]]*Yd[2, 3] + Conjugate[ZDR[gt1, 3]]*Yd[3, 3]))*ZA[gt3, 1])/Sqrt[2]}, {-((IndexDelta[ct1, ct2]*ZA[gt3, 1]*(ZDL[gt1, 1]*(Conjugate[Yd[1, 1]]*ZDR[gt2, 1] + Conjugate[Yd[2, 1]]*ZDR[gt2, 2] + Conjugate[Yd[3, 1]]*ZDR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[Yd[1, 2]]*ZDR[gt2, 1] + Conjugate[Yd[2, 2]]*ZDR[gt2, 2] + Conjugate[Yd[3, 2]]*ZDR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[Yd[1, 3]]*ZDR[gt2, 1] + Conjugate[Yd[2, 3]]*ZDR[gt2, 2] + Conjugate[Yd[3, 3]]*ZDR[gt2, 3])))/Sqrt[2])}},
 C[-F[2, {gt1}], F[2, {gt2}], S[2, {gt3}]] == {{((Conjugate[ZEL[gt2, 1]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 1] + Conjugate[ZER[gt1, 2]]*Ye[2, 1] + Conjugate[ZER[gt1, 3]]*Ye[3, 1]) + Conjugate[ZEL[gt2, 2]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 2] + Conjugate[ZER[gt1, 2]]*Ye[2, 2] + Conjugate[ZER[gt1, 3]]*Ye[3, 2]) + Conjugate[ZEL[gt2, 3]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 3] + Conjugate[ZER[gt1, 2]]*Ye[2, 3] + Conjugate[ZER[gt1, 3]]*Ye[3, 3]))*ZA[gt3, 1])/Sqrt[2]}, {-((ZA[gt3, 1]*(ZEL[gt1, 1]*(Conjugate[Ye[1, 1]]*ZER[gt2, 1] + Conjugate[Ye[2, 1]]*ZER[gt2, 2] + Conjugate[Ye[3, 1]]*ZER[gt2, 3]) + ZEL[gt1, 2]*(Conjugate[Ye[1, 2]]*ZER[gt2, 1] + Conjugate[Ye[2, 2]]*ZER[gt2, 2] + Conjugate[Ye[3, 2]]*ZER[gt2, 3]) + ZEL[gt1, 3]*(Conjugate[Ye[1, 3]]*ZER[gt2, 1] + Conjugate[Ye[2, 3]]*ZER[gt2, 2] + Conjugate[Ye[3, 3]]*ZER[gt2, 3])))/Sqrt[2])}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], S[2, {gt3}]] == {{-((IndexDelta[ct1, ct2]*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 1] + Conjugate[ZUR[gt1, 2]]*Yu[2, 1] + Conjugate[ZUR[gt1, 3]]*Yu[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 2] + Conjugate[ZUR[gt1, 2]]*Yu[2, 2] + Conjugate[ZUR[gt1, 3]]*Yu[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 3] + Conjugate[ZUR[gt1, 2]]*Yu[2, 3] + Conjugate[ZUR[gt1, 3]]*Yu[3, 3]))*ZA[gt3, 1])/Sqrt[2])}, {(IndexDelta[ct1, ct2]*ZA[gt3, 1]*(ZUL[gt1, 1]*(Conjugate[Yu[1, 1]]*ZUR[gt2, 1] + Conjugate[Yu[2, 1]]*ZUR[gt2, 2] + Conjugate[Yu[3, 1]]*ZUR[gt2, 3]) + ZUL[gt1, 2]*(Conjugate[Yu[1, 2]]*ZUR[gt2, 1] + Conjugate[Yu[2, 2]]*ZUR[gt2, 2] + Conjugate[Yu[3, 2]]*ZUR[gt2, 3]) + ZUL[gt1, 3]*(Conjugate[Yu[1, 3]]*ZUR[gt2, 1] + Conjugate[Yu[2, 3]]*ZUR[gt2, 2] + Conjugate[Yu[3, 3]]*ZUR[gt2, 3])))/Sqrt[2]}},
 C[F[1, {gt1}], F[1, {gt2}], S[2, {gt3}]] == {{(-((Conjugate[UV[gt2, 4]]*(Conjugate[UV[gt1, 1]]*Yv[1, 1] + Conjugate[UV[gt1, 2]]*Yv[2, 1] + Conjugate[UV[gt1, 3]]*Yv[3, 1]) + Conjugate[UV[gt2, 5]]*(Conjugate[UV[gt1, 1]]*Yv[1, 2] + Conjugate[UV[gt1, 2]]*Yv[2, 2] + Conjugate[UV[gt1, 3]]*Yv[3, 2]) + Conjugate[UV[gt2, 6]]*(Conjugate[UV[gt1, 1]]*Yv[1, 3] + Conjugate[UV[gt1, 2]]*Yv[2, 3] + Conjugate[UV[gt1, 3]]*Yv[3, 3]))*ZA[gt3, 1]) - (Conjugate[UV[gt1, 4]]*(Conjugate[UV[gt2, 1]]*Yv[1, 1] + Conjugate[UV[gt2, 2]]*Yv[2, 1] + Conjugate[UV[gt2, 3]]*Yv[3, 1]) + Conjugate[UV[gt1, 5]]*(Conjugate[UV[gt2, 1]]*Yv[1, 2] + Conjugate[UV[gt2, 2]]*Yv[2, 2] + Conjugate[UV[gt2, 3]]*Yv[3, 2]) + Conjugate[UV[gt1, 6]]*(Conjugate[UV[gt2, 1]]*Yv[1, 3] + Conjugate[UV[gt2, 2]]*Yv[2, 3] + Conjugate[UV[gt2, 3]]*Yv[3, 3]))*ZA[gt3, 1] + (Conjugate[UV[gt2, 4]]*(Conjugate[UV[gt1, 4]]*Yx[1, 1] + Conjugate[UV[gt1, 5]]*Yx[2, 1] + Conjugate[UV[gt1, 6]]*Yx[3, 1]) + Conjugate[UV[gt1, 4]]*(Conjugate[UV[gt2, 4]]*Yx[1, 1] + Conjugate[UV[gt2, 5]]*Yx[2, 1] + Conjugate[UV[gt2, 6]]*Yx[3, 1]) + Conjugate[UV[gt2, 5]]*(Conjugate[UV[gt1, 4]]*Yx[1, 2] + Conjugate[UV[gt1, 5]]*Yx[2, 2] + Conjugate[UV[gt1, 6]]*Yx[3, 2]) + Conjugate[UV[gt1, 5]]*(Conjugate[UV[gt2, 4]]*Yx[1, 2] + Conjugate[UV[gt2, 5]]*Yx[2, 2] + Conjugate[UV[gt2, 6]]*Yx[3, 2]) + Conjugate[UV[gt2, 6]]*(Conjugate[UV[gt1, 4]]*Yx[1, 3] + Conjugate[UV[gt1, 5]]*Yx[2, 3] + Conjugate[UV[gt1, 6]]*Yx[3, 3]) + Conjugate[UV[gt1, 6]]*(Conjugate[UV[gt2, 4]]*Yx[1, 3] + Conjugate[UV[gt2, 5]]*Yx[2, 3] + Conjugate[UV[gt2, 6]]*Yx[3, 3]))*ZA[gt3, 2])/Sqrt[2]}, {((UV[gt1, 4]*(Conjugate[Yv[1, 1]]*UV[gt2, 1] + Conjugate[Yv[2, 1]]*UV[gt2, 2] + Conjugate[Yv[3, 1]]*UV[gt2, 3]) + UV[gt1, 5]*(Conjugate[Yv[1, 2]]*UV[gt2, 1] + Conjugate[Yv[2, 2]]*UV[gt2, 2] + Conjugate[Yv[3, 2]]*UV[gt2, 3]) + UV[gt1, 6]*(Conjugate[Yv[1, 3]]*UV[gt2, 1] + Conjugate[Yv[2, 3]]*UV[gt2, 2] + Conjugate[Yv[3, 3]]*UV[gt2, 3]))*ZA[gt3, 1] + ((Conjugate[Yv[1, 1]]*UV[gt1, 1] + Conjugate[Yv[2, 1]]*UV[gt1, 2] + Conjugate[Yv[3, 1]]*UV[gt1, 3])*UV[gt2, 4] + (Conjugate[Yv[1, 2]]*UV[gt1, 1] + Conjugate[Yv[2, 2]]*UV[gt1, 2] + Conjugate[Yv[3, 2]]*UV[gt1, 3])*UV[gt2, 5] + (Conjugate[Yv[1, 3]]*UV[gt1, 1] + Conjugate[Yv[2, 3]]*UV[gt1, 2] + Conjugate[Yv[3, 3]]*UV[gt1, 3])*UV[gt2, 6])*ZA[gt3, 1] - ((Conjugate[Yx[1, 1]]*UV[gt1, 4] + Conjugate[Yx[2, 1]]*UV[gt1, 5] + Conjugate[Yx[3, 1]]*UV[gt1, 6])*UV[gt2, 4] + (Conjugate[Yx[1, 2]]*UV[gt1, 4] + Conjugate[Yx[2, 2]]*UV[gt1, 5] + Conjugate[Yx[3, 2]]*UV[gt1, 6])*UV[gt2, 5] + (Conjugate[Yx[1, 3]]*UV[gt1, 4] + Conjugate[Yx[2, 3]]*UV[gt1, 5] + Conjugate[Yx[3, 3]]*UV[gt1, 6])*UV[gt2, 6] + UV[gt1, 4]*(Conjugate[Yx[1, 1]]*UV[gt2, 4] + Conjugate[Yx[2, 1]]*UV[gt2, 5] + Conjugate[Yx[3, 1]]*UV[gt2, 6]) + UV[gt1, 5]*(Conjugate[Yx[1, 2]]*UV[gt2, 4] + Conjugate[Yx[2, 2]]*UV[gt2, 5] + Conjugate[Yx[3, 2]]*UV[gt2, 6]) + UV[gt1, 6]*(Conjugate[Yx[1, 3]]*UV[gt2, 4] + Conjugate[Yx[2, 3]]*UV[gt2, 5] + Conjugate[Yx[3, 3]]*UV[gt2, 6]))*ZA[gt3, 2])/Sqrt[2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], S[1, {gt3}]] == {{((-I)*IndexDelta[ct1, ct2]*(Conjugate[ZDL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 1] + Conjugate[ZDR[gt1, 2]]*Yd[2, 1] + Conjugate[ZDR[gt1, 3]]*Yd[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 2] + Conjugate[ZDR[gt1, 2]]*Yd[2, 2] + Conjugate[ZDR[gt1, 3]]*Yd[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 3] + Conjugate[ZDR[gt1, 2]]*Yd[2, 3] + Conjugate[ZDR[gt1, 3]]*Yd[3, 3]))*ZH[gt3, 1])/Sqrt[2]}, {((-I)*IndexDelta[ct1, ct2]*(ZDL[gt1, 1]*(Conjugate[Yd[1, 1]]*ZDR[gt2, 1] + Conjugate[Yd[2, 1]]*ZDR[gt2, 2] + Conjugate[Yd[3, 1]]*ZDR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[Yd[1, 2]]*ZDR[gt2, 1] + Conjugate[Yd[2, 2]]*ZDR[gt2, 2] + Conjugate[Yd[3, 2]]*ZDR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[Yd[1, 3]]*ZDR[gt2, 1] + Conjugate[Yd[2, 3]]*ZDR[gt2, 2] + Conjugate[Yd[3, 3]]*ZDR[gt2, 3]))*ZH[gt3, 1])/Sqrt[2]}},
 C[-F[3, {gt1, ct1}], F[4, {gt2, ct2}], -S[3]] == {{(-I)*IndexDelta[ct1, ct2]*(Conjugate[ZDL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 1] + Conjugate[ZUR[gt1, 2]]*Yu[2, 1] + Conjugate[ZUR[gt1, 3]]*Yu[3, 1]) + Conjugate[ZDL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 2] + Conjugate[ZUR[gt1, 2]]*Yu[2, 2] + Conjugate[ZUR[gt1, 3]]*Yu[3, 2]) + Conjugate[ZDL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 3] + Conjugate[ZUR[gt1, 2]]*Yu[2, 3] + Conjugate[ZUR[gt1, 3]]*Yu[3, 3]))}, {I*IndexDelta[ct1, ct2]*((Conjugate[Yd[1, 1]]*ZDR[gt2, 1] + Conjugate[Yd[2, 1]]*ZDR[gt2, 2] + Conjugate[Yd[3, 1]]*ZDR[gt2, 3])*ZUL[gt1, 1] + (Conjugate[Yd[1, 2]]*ZDR[gt2, 1] + Conjugate[Yd[2, 2]]*ZDR[gt2, 2] + Conjugate[Yd[3, 2]]*ZDR[gt2, 3])*ZUL[gt1, 2] + (Conjugate[Yd[1, 3]]*ZDR[gt2, 1] + Conjugate[Yd[2, 3]]*ZDR[gt2, 2] + Conjugate[Yd[3, 3]]*ZDR[gt2, 3])*ZUL[gt1, 3])}},
 C[F[1, {gt1}], F[2, {gt2}], -S[3]] == {{(-I)*(Conjugate[UV[gt1, 4]]*(Conjugate[ZEL[gt2, 1]]*Yv[1, 1] + Conjugate[ZEL[gt2, 2]]*Yv[2, 1] + Conjugate[ZEL[gt2, 3]]*Yv[3, 1]) + Conjugate[UV[gt1, 5]]*(Conjugate[ZEL[gt2, 1]]*Yv[1, 2] + Conjugate[ZEL[gt2, 2]]*Yv[2, 2] + Conjugate[ZEL[gt2, 3]]*Yv[3, 2]) + Conjugate[UV[gt1, 6]]*(Conjugate[ZEL[gt2, 1]]*Yv[1, 3] + Conjugate[ZEL[gt2, 2]]*Yv[2, 3] + Conjugate[ZEL[gt2, 3]]*Yv[3, 3]))}, {I*(UV[gt1, 1]*(Conjugate[Ye[1, 1]]*ZER[gt2, 1] + Conjugate[Ye[2, 1]]*ZER[gt2, 2] + Conjugate[Ye[3, 1]]*ZER[gt2, 3]) + UV[gt1, 2]*(Conjugate[Ye[1, 2]]*ZER[gt2, 1] + Conjugate[Ye[2, 2]]*ZER[gt2, 2] + Conjugate[Ye[3, 2]]*ZER[gt2, 3]) + UV[gt1, 3]*(Conjugate[Ye[1, 3]]*ZER[gt2, 1] + Conjugate[Ye[2, 3]]*ZER[gt2, 2] + Conjugate[Ye[3, 3]]*ZER[gt2, 3]))}},
 C[-F[2, {gt1}], F[2, {gt2}], S[1, {gt3}]] == {{((-I)*(Conjugate[ZEL[gt2, 1]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 1] + Conjugate[ZER[gt1, 2]]*Ye[2, 1] + Conjugate[ZER[gt1, 3]]*Ye[3, 1]) + Conjugate[ZEL[gt2, 2]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 2] + Conjugate[ZER[gt1, 2]]*Ye[2, 2] + Conjugate[ZER[gt1, 3]]*Ye[3, 2]) + Conjugate[ZEL[gt2, 3]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 3] + Conjugate[ZER[gt1, 2]]*Ye[2, 3] + Conjugate[ZER[gt1, 3]]*Ye[3, 3]))*ZH[gt3, 1])/Sqrt[2]}, {((-I)*(ZEL[gt1, 1]*(Conjugate[Ye[1, 1]]*ZER[gt2, 1] + Conjugate[Ye[2, 1]]*ZER[gt2, 2] + Conjugate[Ye[3, 1]]*ZER[gt2, 3]) + ZEL[gt1, 2]*(Conjugate[Ye[1, 2]]*ZER[gt2, 1] + Conjugate[Ye[2, 2]]*ZER[gt2, 2] + Conjugate[Ye[3, 2]]*ZER[gt2, 3]) + ZEL[gt1, 3]*(Conjugate[Ye[1, 3]]*ZER[gt2, 1] + Conjugate[Ye[2, 3]]*ZER[gt2, 2] + Conjugate[Ye[3, 3]]*ZER[gt2, 3]))*ZH[gt3, 1])/Sqrt[2]}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], S[1, {gt3}]] == {{((-I)*IndexDelta[ct1, ct2]*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 1] + Conjugate[ZUR[gt1, 2]]*Yu[2, 1] + Conjugate[ZUR[gt1, 3]]*Yu[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 2] + Conjugate[ZUR[gt1, 2]]*Yu[2, 2] + Conjugate[ZUR[gt1, 3]]*Yu[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZUR[gt1, 1]]*Yu[1, 3] + Conjugate[ZUR[gt1, 2]]*Yu[2, 3] + Conjugate[ZUR[gt1, 3]]*Yu[3, 3]))*ZH[gt3, 1])/Sqrt[2]}, {((-I)*IndexDelta[ct1, ct2]*ZH[gt3, 1]*(ZUL[gt1, 1]*(Conjugate[Yu[1, 1]]*ZUR[gt2, 1] + Conjugate[Yu[2, 1]]*ZUR[gt2, 2] + Conjugate[Yu[3, 1]]*ZUR[gt2, 3]) + ZUL[gt1, 2]*(Conjugate[Yu[1, 2]]*ZUR[gt2, 1] + Conjugate[Yu[2, 2]]*ZUR[gt2, 2] + Conjugate[Yu[3, 2]]*ZUR[gt2, 3]) + ZUL[gt1, 3]*(Conjugate[Yu[1, 3]]*ZUR[gt2, 1] + Conjugate[Yu[2, 3]]*ZUR[gt2, 2] + Conjugate[Yu[3, 3]]*ZUR[gt2, 3])))/Sqrt[2]}},
 C[-F[4, {gt1, ct1}], F[3, {gt2, ct2}], S[3]] == {{I*IndexDelta[ct1, ct2]*(Conjugate[ZUL[gt2, 1]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 1] + Conjugate[ZDR[gt1, 2]]*Yd[2, 1] + Conjugate[ZDR[gt1, 3]]*Yd[3, 1]) + Conjugate[ZUL[gt2, 2]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 2] + Conjugate[ZDR[gt1, 2]]*Yd[2, 2] + Conjugate[ZDR[gt1, 3]]*Yd[3, 2]) + Conjugate[ZUL[gt2, 3]]*(Conjugate[ZDR[gt1, 1]]*Yd[1, 3] + Conjugate[ZDR[gt1, 2]]*Yd[2, 3] + Conjugate[ZDR[gt1, 3]]*Yd[3, 3]))}, {(-I)*IndexDelta[ct1, ct2]*(ZDL[gt1, 1]*(Conjugate[Yu[1, 1]]*ZUR[gt2, 1] + Conjugate[Yu[2, 1]]*ZUR[gt2, 2] + Conjugate[Yu[3, 1]]*ZUR[gt2, 3]) + ZDL[gt1, 2]*(Conjugate[Yu[1, 2]]*ZUR[gt2, 1] + Conjugate[Yu[2, 2]]*ZUR[gt2, 2] + Conjugate[Yu[3, 2]]*ZUR[gt2, 3]) + ZDL[gt1, 3]*(Conjugate[Yu[1, 3]]*ZUR[gt2, 1] + Conjugate[Yu[2, 3]]*ZUR[gt2, 2] + Conjugate[Yu[3, 3]]*ZUR[gt2, 3]))}},
 C[F[1, {gt1}], F[1, {gt2}], S[1, {gt3}]] == {{((-I)*((Conjugate[UV[gt2, 4]]*(Conjugate[UV[gt1, 1]]*Yv[1, 1] + Conjugate[UV[gt1, 2]]*Yv[2, 1] + Conjugate[UV[gt1, 3]]*Yv[3, 1]) + Conjugate[UV[gt2, 5]]*(Conjugate[UV[gt1, 1]]*Yv[1, 2] + Conjugate[UV[gt1, 2]]*Yv[2, 2] + Conjugate[UV[gt1, 3]]*Yv[3, 2]) + Conjugate[UV[gt2, 6]]*(Conjugate[UV[gt1, 1]]*Yv[1, 3] + Conjugate[UV[gt1, 2]]*Yv[2, 3] + Conjugate[UV[gt1, 3]]*Yv[3, 3]))*ZH[gt3, 1] + (Conjugate[UV[gt1, 4]]*(Conjugate[UV[gt2, 1]]*Yv[1, 1] + Conjugate[UV[gt2, 2]]*Yv[2, 1] + Conjugate[UV[gt2, 3]]*Yv[3, 1]) + Conjugate[UV[gt1, 5]]*(Conjugate[UV[gt2, 1]]*Yv[1, 2] + Conjugate[UV[gt2, 2]]*Yv[2, 2] + Conjugate[UV[gt2, 3]]*Yv[3, 2]) + Conjugate[UV[gt1, 6]]*(Conjugate[UV[gt2, 1]]*Yv[1, 3] + Conjugate[UV[gt2, 2]]*Yv[2, 3] + Conjugate[UV[gt2, 3]]*Yv[3, 3]))*ZH[gt3, 1] + (Conjugate[UV[gt2, 4]]*(Conjugate[UV[gt1, 4]]*Yx[1, 1] + Conjugate[UV[gt1, 5]]*Yx[2, 1] + Conjugate[UV[gt1, 6]]*Yx[3, 1]) + Conjugate[UV[gt1, 4]]*(Conjugate[UV[gt2, 4]]*Yx[1, 1] + Conjugate[UV[gt2, 5]]*Yx[2, 1] + Conjugate[UV[gt2, 6]]*Yx[3, 1]) + Conjugate[UV[gt2, 5]]*(Conjugate[UV[gt1, 4]]*Yx[1, 2] + Conjugate[UV[gt1, 5]]*Yx[2, 2] + Conjugate[UV[gt1, 6]]*Yx[3, 2]) + Conjugate[UV[gt1, 5]]*(Conjugate[UV[gt2, 4]]*Yx[1, 2] + Conjugate[UV[gt2, 5]]*Yx[2, 2] + Conjugate[UV[gt2, 6]]*Yx[3, 2]) + Conjugate[UV[gt2, 6]]*(Conjugate[UV[gt1, 4]]*Yx[1, 3] + Conjugate[UV[gt1, 5]]*Yx[2, 3] + Conjugate[UV[gt1, 6]]*Yx[3, 3]) + Conjugate[UV[gt1, 6]]*(Conjugate[UV[gt2, 4]]*Yx[1, 3] + Conjugate[UV[gt2, 5]]*Yx[2, 3] + Conjugate[UV[gt2, 6]]*Yx[3, 3]))*ZH[gt3, 2]))/Sqrt[2]}, {((-I)*((UV[gt1, 4]*(Conjugate[Yv[1, 1]]*UV[gt2, 1] + Conjugate[Yv[2, 1]]*UV[gt2, 2] + Conjugate[Yv[3, 1]]*UV[gt2, 3]) + UV[gt1, 5]*(Conjugate[Yv[1, 2]]*UV[gt2, 1] + Conjugate[Yv[2, 2]]*UV[gt2, 2] + Conjugate[Yv[3, 2]]*UV[gt2, 3]) + UV[gt1, 6]*(Conjugate[Yv[1, 3]]*UV[gt2, 1] + Conjugate[Yv[2, 3]]*UV[gt2, 2] + Conjugate[Yv[3, 3]]*UV[gt2, 3]))*ZH[gt3, 1] + ((Conjugate[Yv[1, 1]]*UV[gt1, 1] + Conjugate[Yv[2, 1]]*UV[gt1, 2] + Conjugate[Yv[3, 1]]*UV[gt1, 3])*UV[gt2, 4] + (Conjugate[Yv[1, 2]]*UV[gt1, 1] + Conjugate[Yv[2, 2]]*UV[gt1, 2] + Conjugate[Yv[3, 2]]*UV[gt1, 3])*UV[gt2, 5] + (Conjugate[Yv[1, 3]]*UV[gt1, 1] + Conjugate[Yv[2, 3]]*UV[gt1, 2] + Conjugate[Yv[3, 3]]*UV[gt1, 3])*UV[gt2, 6])*ZH[gt3, 1] + ((Conjugate[Yx[1, 1]]*UV[gt1, 4] + Conjugate[Yx[2, 1]]*UV[gt1, 5] + Conjugate[Yx[3, 1]]*UV[gt1, 6])*UV[gt2, 4] + (Conjugate[Yx[1, 2]]*UV[gt1, 4] + Conjugate[Yx[2, 2]]*UV[gt1, 5] + Conjugate[Yx[3, 2]]*UV[gt1, 6])*UV[gt2, 5] + (Conjugate[Yx[1, 3]]*UV[gt1, 4] + Conjugate[Yx[2, 3]]*UV[gt1, 5] + Conjugate[Yx[3, 3]]*UV[gt1, 6])*UV[gt2, 6] + UV[gt1, 4]*(Conjugate[Yx[1, 1]]*UV[gt2, 4] + Conjugate[Yx[2, 1]]*UV[gt2, 5] + Conjugate[Yx[3, 1]]*UV[gt2, 6]) + UV[gt1, 5]*(Conjugate[Yx[1, 2]]*UV[gt2, 4] + Conjugate[Yx[2, 2]]*UV[gt2, 5] + Conjugate[Yx[3, 2]]*UV[gt2, 6]) + UV[gt1, 6]*(Conjugate[Yx[1, 3]]*UV[gt2, 4] + Conjugate[Yx[2, 3]]*UV[gt2, 5] + Conjugate[Yx[3, 3]]*UV[gt2, 6]))*ZH[gt3, 2]))/Sqrt[2]}},
 C[-F[2, {gt1}], F[1, {gt2}], S[3]] == {{I*(Conjugate[UV[gt2, 1]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 1] + Conjugate[ZER[gt1, 2]]*Ye[2, 1] + Conjugate[ZER[gt1, 3]]*Ye[3, 1]) + Conjugate[UV[gt2, 2]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 2] + Conjugate[ZER[gt1, 2]]*Ye[2, 2] + Conjugate[ZER[gt1, 3]]*Ye[3, 2]) + Conjugate[UV[gt2, 3]]*(Conjugate[ZER[gt1, 1]]*Ye[1, 3] + Conjugate[ZER[gt1, 2]]*Ye[2, 3] + Conjugate[ZER[gt1, 3]]*Ye[3, 3]))}, {(-I)*(UV[gt2, 4]*(Conjugate[Yv[1, 1]]*ZEL[gt1, 1] + Conjugate[Yv[2, 1]]*ZEL[gt1, 2] + Conjugate[Yv[3, 1]]*ZEL[gt1, 3]) + UV[gt2, 5]*(Conjugate[Yv[1, 2]]*ZEL[gt1, 1] + Conjugate[Yv[2, 2]]*ZEL[gt1, 2] + Conjugate[Yv[3, 2]]*ZEL[gt1, 3]) + UV[gt2, 6]*(Conjugate[Yv[1, 3]]*ZEL[gt1, 1] + Conjugate[Yv[2, 3]]*ZEL[gt1, 2] + Conjugate[Yv[3, 3]]*ZEL[gt1, 3]))}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[5, {ct3}]] == {{(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}, {(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[1]] == {{(-I/6)*(CTW*(g1 + 2*gYB) - 3*g2*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(I/3)*CTW*(g1 - gYB)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[2]] == {{(I/6)*(3*CTW*CTWp*g2 + CTWp*(g1 + 2*gYB)*STW - (2*gBL + gBY)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(-I/3)*(CTWp*(g1 - gYB)*STW + (gBL - gBY)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[4, {gt1, ct1}], F[4, {gt2, ct2}], V[10]] == {{(-I/6)*(CTWp*(2*gBL + gBY) + (3*CTW*g2 + (g1 + 2*gYB)*STW)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(I/3)*(CTWp*(-gBL + gBY) + (g1 - gYB)*STW*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[3, {gt1, ct1}], F[4, {gt2, ct2}], -V[3]] == {{((-I)*g2*IndexDelta[ct1, ct2]*(Conjugate[ZDL[gt2, 1]]*ZUL[gt1, 1] + Conjugate[ZDL[gt2, 2]]*ZUL[gt1, 2] + Conjugate[ZDL[gt2, 3]]*ZUL[gt1, 3]))/Sqrt[2]}, {0}},
 C[F[1, {gt1}], F[2, {gt2}], -V[3]] == {{((-I)*g2*(Conjugate[ZEL[gt2, 1]]*UV[gt1, 1] + Conjugate[ZEL[gt2, 2]]*UV[gt1, 2] + Conjugate[ZEL[gt2, 3]]*UV[gt1, 3]))/Sqrt[2]}, {0}},
 C[-F[2, {gt1}], F[2, {gt2}], V[1]] == {{(I/2)*(CTW*(g1 + 2*gYB) + g2*STW)*IndexDelta[gt1, gt2]}, {I*CTW*(g1 + gYB)*IndexDelta[gt1, gt2]}},
 C[-F[2, {gt1}], F[2, {gt2}], V[2]] == {{(I/2)*(CTW*CTWp*g2 - CTWp*(g1 + 2*gYB)*STW + (2*gBL + gBY)*STWp)*IndexDelta[gt1, gt2]}, {(-I)*(CTWp*(g1 + gYB)*STW - (gBL + gBY)*STWp)*IndexDelta[gt1, gt2]}},
 C[-F[2, {gt1}], F[2, {gt2}], V[10]] == {{(I/2)*(CTWp*(2*gBL + gBY) + (-(CTW*g2) + (g1 + 2*gYB)*STW)*STWp)*IndexDelta[gt1, gt2]}, {I*(CTWp*(gBL + gBY) + (g1 + gYB)*STW*STWp)*IndexDelta[gt1, gt2]}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[5, {ct3}]] == {{(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}, {(-I/2)*g3*IndexDelta[gt1, gt2]*Lam[ct3, ct1, ct2]}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[1]] == {{(-I/6)*(CTW*(g1 + 2*gYB) + 3*g2*STW)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(-I/3)*CTW*(2*g1 + gYB)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[4, {gt1, ct1}], F[3, {gt2, ct2}], V[3]] == {{((-I)*g2*IndexDelta[ct1, ct2]*(Conjugate[ZUL[gt2, 1]]*ZDL[gt1, 1] + Conjugate[ZUL[gt2, 2]]*ZDL[gt1, 2] + Conjugate[ZUL[gt2, 3]]*ZDL[gt1, 3]))/Sqrt[2]}, {0}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[2]] == {{(-I/6)*(3*CTW*CTWp*g2 - CTWp*(g1 + 2*gYB)*STW + (2*gBL + gBY)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(I/3)*(CTWp*(2*g1 + gYB)*STW - (gBL + 2*gBY)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[-F[3, {gt1, ct1}], F[3, {gt2, ct2}], V[10]] == {{(-I/6)*(CTWp*(2*gBL + gBY) + (-3*CTW*g2 + (g1 + 2*gYB)*STW)*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}, {(-I/3)*(CTWp*(gBL + 2*gBY) + (2*g1 + gYB)*STW*STWp)*IndexDelta[ct1, ct2]*IndexDelta[gt1, gt2]}},
 C[F[1, {gt1}], F[1, {gt2}], V[1]] == {{(I/2)*((CTW*(g1 + 2*gYB) - g2*STW)*(Conjugate[UV[gt2, 1]]*UV[gt1, 1] + Conjugate[UV[gt2, 2]]*UV[gt1, 2] + Conjugate[UV[gt2, 3]]*UV[gt1, 3]) - 2*CTW*gYB*(Conjugate[UV[gt2, 4]]*UV[gt1, 4] + Conjugate[UV[gt2, 5]]*UV[gt1, 5] + Conjugate[UV[gt2, 6]]*UV[gt1, 6]))}, {(-I/2)*((CTW*(g1 + 2*gYB) - g2*STW)*(Conjugate[UV[gt1, 1]]*UV[gt2, 1] + Conjugate[UV[gt1, 2]]*UV[gt2, 2] + Conjugate[UV[gt1, 3]]*UV[gt2, 3]) - 2*CTW*gYB*(Conjugate[UV[gt1, 4]]*UV[gt2, 4] + Conjugate[UV[gt1, 5]]*UV[gt2, 5] + Conjugate[UV[gt1, 6]]*UV[gt2, 6]))}},
 C[F[1, {gt1}], F[1, {gt2}], V[2]] == {{(-I/2)*((CTW*CTWp*g2 + CTWp*(g1 + 2*gYB)*STW - (2*gBL + gBY)*STWp)*(Conjugate[UV[gt2, 1]]*UV[gt1, 1] + Conjugate[UV[gt2, 2]]*UV[gt1, 2] + Conjugate[UV[gt2, 3]]*UV[gt1, 3]) + 2*(-(CTWp*gYB*STW) + gBL*STWp)*(Conjugate[UV[gt2, 4]]*UV[gt1, 4] + Conjugate[UV[gt2, 5]]*UV[gt1, 5] + Conjugate[UV[gt2, 6]]*UV[gt1, 6]))}, {(I/2)*((CTW*CTWp*g2 + CTWp*(g1 + 2*gYB)*STW - (2*gBL + gBY)*STWp)*(Conjugate[UV[gt1, 1]]*UV[gt2, 1] + Conjugate[UV[gt1, 2]]*UV[gt2, 2] + Conjugate[UV[gt1, 3]]*UV[gt2, 3]) + 2*(-(CTWp*gYB*STW) + gBL*STWp)*(Conjugate[UV[gt1, 4]]*UV[gt2, 4] + Conjugate[UV[gt1, 5]]*UV[gt2, 5] + Conjugate[UV[gt1, 6]]*UV[gt2, 6]))}},
 C[F[1, {gt1}], F[1, {gt2}], V[10]] == {{(I/2)*((CTWp*(2*gBL + gBY) + (CTW*g2 + (g1 + 2*gYB)*STW)*STWp)*(Conjugate[UV[gt2, 1]]*UV[gt1, 1] + Conjugate[UV[gt2, 2]]*UV[gt1, 2] + Conjugate[UV[gt2, 3]]*UV[gt1, 3]) - 2*(CTWp*gBL + gYB*STW*STWp)*(Conjugate[UV[gt2, 4]]*UV[gt1, 4] + Conjugate[UV[gt2, 5]]*UV[gt1, 5] + Conjugate[UV[gt2, 6]]*UV[gt1, 6]))}, {(-I/2)*((CTWp*(2*gBL + gBY) + (CTW*g2 + (g1 + 2*gYB)*STW)*STWp)*(Conjugate[UV[gt1, 1]]*UV[gt2, 1] + Conjugate[UV[gt1, 2]]*UV[gt2, 2] + Conjugate[UV[gt1, 3]]*UV[gt2, 3]) - 2*(CTWp*gBL + gYB*STW*STWp)*(Conjugate[UV[gt1, 4]]*UV[gt2, 4] + Conjugate[UV[gt1, 5]]*UV[gt2, 5] + Conjugate[UV[gt1, 6]]*UV[gt2, 6]))}},
 C[-F[2, {gt1}], F[1, {gt2}], V[3]] == {{((-I)*g2*(Conjugate[UV[gt2, 1]]*ZEL[gt1, 1] + Conjugate[UV[gt2, 2]]*ZEL[gt1, 2] + Conjugate[UV[gt2, 3]]*ZEL[gt1, 3]))/Sqrt[2]}, {0}},
 C[S[2, {gt1}], S[2, {gt2}], S[1, {gt3}]] == {{I*(ZA[gt1, 2]*ZA[gt2, 2]*(lam3*v*ZH[gt3, 1] + 2*lam2*vX*ZH[gt3, 2]) + ZA[gt1, 1]*ZA[gt2, 1]*(2*lam1*v*ZH[gt3, 1] + lam3*vX*ZH[gt3, 2]))}},
 C[S[1, {gt1}], S[1, {gt2}], S[1, {gt3}]] == {{I*(ZH[gt1, 2]*(lam3*ZH[gt2, 1]*(vX*ZH[gt3, 1] + v*ZH[gt3, 2]) + ZH[gt2, 2]*(lam3*v*ZH[gt3, 1] + 6*lam2*vX*ZH[gt3, 2])) + ZH[gt1, 1]*(lam3*ZH[gt2, 2]*(vX*ZH[gt3, 1] + v*ZH[gt3, 2]) + ZH[gt2, 1]*(6*lam1*v*ZH[gt3, 1] + lam3*vX*ZH[gt3, 2])))}},
 C[S[1, {gt1}], S[3], -S[3]] == {{I*(2*lam1*v*ZH[gt1, 1] + lam3*vX*ZH[gt1, 2])}},
 C[S[2, {gt1}], S[1, {gt2}], V[1]] == {{(-((CTW*g1 - g2*STW)*ZA[gt1, 1]*ZH[gt2, 1]) - 4*CTW*gYB*ZA[gt1, 2]*ZH[gt2, 2])/2}},
 C[S[2, {gt1}], S[1, {gt2}], V[2]] == {{((CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*ZA[gt1, 1]*ZH[gt2, 1] + 4*(CTWp*gYB*STW - gBL*STWp)*ZA[gt1, 2]*ZH[gt2, 2])/2}},
 C[S[2, {gt1}], S[1, {gt2}], V[10]] == {{(-((CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*ZA[gt1, 1]*ZH[gt2, 1]) - 4*(CTWp*gBL + gYB*STW*STWp)*ZA[gt1, 2]*ZH[gt2, 2])/2}},
 C[S[2, {gt1}], S[3], -V[3]] == {{(g2*ZA[gt1, 1])/2}},
 C[S[2, {gt1}], -S[3], V[3]] == {{(g2*ZA[gt1, 1])/2}},
 C[S[1, {gt1}], S[3], -V[3]] == {{(I/2)*g2*ZH[gt1, 1]}},
 C[S[1, {gt1}], -S[3], V[3]] == {{(-I/2)*g2*ZH[gt1, 1]}},
 C[S[3], -S[3], V[1]] == {{(I/2)*(CTW*g1 + g2*STW)}},
 C[S[3], -S[3], V[2]] == {{(I/2)*(CTW*CTWp*g2 - CTWp*g1*STW + gBY*STWp)}},
 C[S[3], -S[3], V[10]] == {{(I/2)*(CTWp*gBY + (-(CTW*g2) + g1*STW)*STWp)}},
 C[S[1, {gt1}], V[1], V[1]] == {{(I/2)*((CTW*g1 - g2*STW)^2*v*ZH[gt1, 1] + 16*CTW^2*gYB^2*vX*ZH[gt1, 2])}},
 C[S[1, {gt1}], V[1], V[2]] == {{(-I/2)*((CTW*g1 - g2*STW)*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*v*ZH[gt1, 1] + 8*gYB*(CTWp*gYB*S2TW - 2*CTW*gBL*STWp)*vX*ZH[gt1, 2])}},
 C[S[1, {gt1}], V[1], V[10]] == {{(I/2)*((CTW*g1 - g2*STW)*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*v*ZH[gt1, 1] + 8*gYB*(2*CTW*CTWp*gBL + gYB*S2TW*STWp)*vX*ZH[gt1, 2])}},
 C[S[1, {gt1}], -V[3], V[3]] == {{(I/2)*g2^2*v*ZH[gt1, 1]}},
 C[S[1, {gt1}], V[2], V[2]] == {{(I/2)*((CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)^2*v*ZH[gt1, 1] + 16*(CTWp*gYB*STW - gBL*STWp)^2*vX*ZH[gt1, 2])}},
 C[S[1, {gt1}], V[2], V[10]] == {{(-I/2)*((CTWp^2*g1*gBY*STW + CTW^2*CTWp*g2^2*STWp + CTWp*(-gBY^2 + g1^2*STW^2)*STWp - g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))*v*ZH[gt1, 1] + 8*(-(gBL^2*S2TWp) + 2*CTWp^2*gBL*gYB*STW + gYB^2*S2TWp*STW^2 - 2*gBL*gYB*STW*STWp^2)*vX*ZH[gt1, 2])}},
 C[S[1, {gt1}], V[10], V[10]] == {{(I/2)*((CTWp*gBY + (CTW*g2 + g1*STW)*STWp)^2*v*ZH[gt1, 1] + 16*(CTWp*gBL + gYB*STW*STWp)^2*vX*ZH[gt1, 2])}},
 C[S[3], -V[3], V[1]] == {{(-I/2)*CTW*g1*g2*v}},
 C[S[3], -V[3], V[2]] == {{(I/2)*g2*(CTWp*g1*STW - gBY*STWp)*v}},
 C[S[3], -V[3], V[10]] == {{(-I/2)*g2*(CTWp*gBY + g1*STW*STWp)*v}},
 C[-S[3], V[1], V[3]] == {{(-I/2)*CTW*g1*g2*v}},
 C[-S[3], V[3], V[2]] == {{(I/2)*g2*(CTWp*g1*STW - gBY*STWp)*v}},
 C[-S[3], V[3], V[10]] == {{(-I/2)*g2*(CTWp*gBY + g1*STW*STWp)*v}},
 C[S[2, {gt1}], S[2, {gt2}], S[2, {gt3}], S[2, {gt4}]] == {{I*(ZA[gt1, 2]*(lam3*ZA[gt2, 1]*(ZA[gt3, 2]*ZA[gt4, 1] + ZA[gt3, 1]*ZA[gt4, 2]) + ZA[gt2, 2]*(lam3*ZA[gt3, 1]*ZA[gt4, 1] + 6*lam2*ZA[gt3, 2]*ZA[gt4, 2])) + ZA[gt1, 1]*(lam3*ZA[gt2, 2]*(ZA[gt3, 2]*ZA[gt4, 1] + ZA[gt3, 1]*ZA[gt4, 2]) + ZA[gt2, 1]*(6*lam1*ZA[gt3, 1]*ZA[gt4, 1] + lam3*ZA[gt3, 2]*ZA[gt4, 2])))}},
 C[S[2, {gt1}], S[2, {gt2}], S[1, {gt3}], S[1, {gt4}]] == {{I*(ZA[gt1, 2]*ZA[gt2, 2]*(lam3*ZH[gt3, 1]*ZH[gt4, 1] + 2*lam2*ZH[gt3, 2]*ZH[gt4, 2]) + ZA[gt1, 1]*ZA[gt2, 1]*(2*lam1*ZH[gt3, 1]*ZH[gt4, 1] + lam3*ZH[gt3, 2]*ZH[gt4, 2]))}},
 C[S[2, {gt1}], S[2, {gt2}], S[3], -S[3]] == {{I*(2*lam1*ZA[gt1, 1]*ZA[gt2, 1] + lam3*ZA[gt1, 2]*ZA[gt2, 2])}},
 C[S[1, {gt1}], S[1, {gt2}], S[1, {gt3}], S[1, {gt4}]] == {{I*(ZH[gt1, 2]*(lam3*ZH[gt2, 1]*(ZH[gt3, 2]*ZH[gt4, 1] + ZH[gt3, 1]*ZH[gt4, 2]) + ZH[gt2, 2]*(lam3*ZH[gt3, 1]*ZH[gt4, 1] + 6*lam2*ZH[gt3, 2]*ZH[gt4, 2])) + ZH[gt1, 1]*(lam3*ZH[gt2, 2]*(ZH[gt3, 2]*ZH[gt4, 1] + ZH[gt3, 1]*ZH[gt4, 2]) + ZH[gt2, 1]*(6*lam1*ZH[gt3, 1]*ZH[gt4, 1] + lam3*ZH[gt3, 2]*ZH[gt4, 2])))}},
 C[S[1, {gt1}], S[1, {gt2}], S[3], -S[3]] == {{I*(2*lam1*ZH[gt1, 1]*ZH[gt2, 1] + lam3*ZH[gt1, 2]*ZH[gt2, 2])}},
 C[S[3], S[3], -S[3], -S[3]] == {{(4*I)*lam1}},
 C[V[5, {ct1}], V[5, {ct2}], V[5, {ct3}]] == {{g3*fSU3[ct1, ct2, ct3]}},
 C[-V[3], V[1], V[3]] == {{I*g2*STW}},
 C[-V[3], V[3], V[2]] == {{(-I)*CTW*CTWp*g2}},
 C[-V[3], V[3], V[10]] == {{I*CTW*g2*STWp}},
 C[S[2, {gt3}], -U[3], U[3]] == {{(g2^2*v*GaugeXi[Wm]*ZA[gt3, 1])/4}},
 C[S[2, {gt3}], -U[4], U[4]] == {{-(g2^2*v*GaugeXi[Wm]*ZA[gt3, 1])/4}},
 C[S[1, {gt3}], -U[2], U[1]] == {{(I/4)*GaugeXi[Z]*((CTW*g1 - g2*STW)*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*v*ZH[gt3, 1] + 8*gYB*(CTWp*gYB*S2TW - 2*CTW*gBL*STWp)*vX*ZH[gt3, 2])}},
 C[S[1, {gt3}], -U[10], U[1]] == {{(-I/4)*GaugeXi[Zp]*((CTW*g1 - g2*STW)*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*v*ZH[gt3, 1] + 8*gYB*(2*CTW*CTWp*gBL + gYB*S2TW*STWp)*vX*ZH[gt3, 2])}},
 C[S[3], -U[3], U[1]] == {{(I/4)*g2*(CTW*g1 + g2*STW)*v*GaugeXi[Wm]}},
 C[-S[3], -U[4], U[1]] == {{(I/4)*g2*(CTW*g1 + g2*STW)*v*GaugeXi[Wm]}},
 C[S[1, {gt3}], -U[3], U[3]] == {{(-I/4)*g2^2*v*GaugeXi[Wm]*ZH[gt3, 1]}},
 C[-S[3], -U[2], U[3]] == {{(-I/4)*g2*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*v*GaugeXi[Z]}},
 C[-S[3], -U[10], U[3]] == {{(I/4)*g2*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*v*GaugeXi[Zp]}},
 C[S[1, {gt3}], -U[4], U[4]] == {{(-I/4)*g2^2*v*GaugeXi[Wm]*ZH[gt3, 1]}},
 C[S[3], -U[2], U[4]] == {{(-I/4)*g2*(CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)*v*GaugeXi[Z]}},
 C[S[3], -U[10], U[4]] == {{(I/4)*g2*(CTWp*gBY + (CTW*g2 + g1*STW)*STWp)*v*GaugeXi[Zp]}},
 C[S[1, {gt3}], -U[2], U[2]] == {{(-I/4)*GaugeXi[Z]*((CTW*CTWp*g2 + CTWp*g1*STW - gBY*STWp)^2*v*ZH[gt3, 1] + 16*(CTWp*gYB*STW - gBL*STWp)^2*vX*ZH[gt3, 2])}},
 C[S[1, {gt3}], -U[10], U[2]] == {{(I/4)*GaugeXi[Zp]*((CTWp^2*g1*gBY*STW + CTW^2*CTWp*g2^2*STWp + CTWp*(-gBY^2 + g1^2*STW^2)*STWp - g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))*v*ZH[gt3, 1] + 8*(-(gBL^2*S2TWp) + 2*CTWp^2*gBL*gYB*STW + gYB^2*S2TWp*STW^2 - 2*gBL*gYB*STW*STWp^2)*vX*ZH[gt3, 2])}},
 C[S[3], -U[3], U[2]] == {{(I/4)*g2*(CTW*CTWp*g2 - CTWp*g1*STW + gBY*STWp)*v*GaugeXi[Wm]}},
 C[-S[3], -U[4], U[2]] == {{(I/4)*g2*(CTW*CTWp*g2 - CTWp*g1*STW + gBY*STWp)*v*GaugeXi[Wm]}},
 C[S[1, {gt3}], -U[2], U[10]] == {{(I/4)*GaugeXi[Z]*((CTWp^2*g1*gBY*STW + CTW^2*CTWp*g2^2*STWp + CTWp*(-gBY^2 + g1^2*STW^2)*STWp - g1*gBY*STW*STWp^2 + CTW*g2*(CTWp^2*gBY + g1*S2TWp*STW - gBY*STWp^2))*v*ZH[gt3, 1] + 8*(-(gBL^2*S2TWp) + 2*CTWp^2*gBL*gYB*STW + gYB^2*S2TWp*STW^2 - 2*gBL*gYB*STW*STWp^2)*vX*ZH[gt3, 2])}},
 C[S[1, {gt3}], -U[10], U[10]] == {{(-I/4)*GaugeXi[Zp]*((CTWp*gBY + (CTW*g2 + g1*STW)*STWp)^2*v*ZH[gt3, 1] + 16*(CTWp*gBL + gYB*STW*STWp)^2*vX*ZH[gt3, 2])}},
 C[S[3], -U[3], U[10]] == {{(I/4)*g2*(CTWp*gBY + (-(CTW*g2) + g1*STW)*STWp)*v*GaugeXi[Wm]}},
 C[-S[3], -U[4], U[10]] == {{(I/4)*g2*(CTWp*gBY + (-(CTW*g2) + g1*STW)*STWp)*v*GaugeXi[Wm]}},
 C[-U[5, {ct1}], U[5, {ct2}], V[5, {ct3}]] == {{g3*fSU3[ct1, ct2, ct3]}, {0}},
 C[-U[3], U[1], V[3]] == {{I*g2*STW}, {0}},
 C[-U[4], U[1], -V[3]] == {{(-I)*g2*STW}, {0}},
 C[-U[3], U[3], V[1]] == {{(-I)*g2*STW}, {0}},
 C[-U[3], U[3], V[2]] == {{(-I)*CTW*CTWp*g2}, {0}},
 C[-U[3], U[3], V[10]] == {{I*CTW*g2*STWp}, {0}},
 C[-U[1], U[3], -V[3]] == {{I*g2*STW}, {0}},
 C[-U[2], U[3], -V[3]] == {{I*CTW*CTWp*g2}, {0}},
 C[-U[10], U[3], -V[3]] == {{(-I)*CTW*g2*STWp}, {0}},
 C[-U[4], U[4], V[1]] == {{I*g2*STW}, {0}},
 C[-U[1], U[4], V[3]] == {{(-I)*g2*STW}, {0}},
 C[-U[2], U[4], V[3]] == {{(-I)*CTW*CTWp*g2}, {0}},
 C[-U[10], U[4], V[3]] == {{I*CTW*g2*STWp}, {0}},
 C[-U[4], U[4], V[2]] == {{I*CTW*CTWp*g2}, {0}},
 C[-U[4], U[4], V[10]] == {{(-I)*CTW*g2*STWp}, {0}},
 C[-U[3], U[2], V[3]] == {{I*CTW*CTWp*g2}, {0}},
 C[-U[4], U[2], -V[3]] == {{(-I)*CTW*CTWp*g2}, {0}},
 C[-U[3], U[10], V[3]] == {{(-I)*CTW*g2*STWp}, {0}},
 C[-U[4], U[10], -V[3]] == {{I*CTW*g2*STWp}, {0}}
 }

 
Conjugate[g1] ^= g1; 
Conjugate[g2] ^= g2; 
Conjugate[g3] ^= g3; 
Conjugate[vX] ^= vX; 
Conjugate[ZZ[a___]] ^= ZZ[a]; 
Conjugate[ZH[a___]] ^= ZH[a]; 
Conjugate[ZA[a___]] ^= ZA[a]; 
Conjugate[aEWinv] ^= aEWinv; 
Conjugate[Gf] ^= Gf; 
