(* --------------------------------------------------------------------------------
   Autogenerated by the happy scrappy WHIZARD model file generator on 11/18/2015 , 12:29:44
   WHIZARD interface svn revision info: $Id: WOMathematicaInterface.m 3666 2012-01-14 17:03:09Z cnspeckn $
   Code generated for WHIZARD / O'Mega version 2.2.3
   Model name: blsm_sarah
   Gauge: Unitarity
   Maximum number of couplings per FORTRAN module: 150
   --------------------------------------------------------------------------------
   
   -------------------------------------------------------------------------------- *)

type gauge = Unitarity | Feynman | Rxi

module type Frules_options =
sig
   val gauge: gauge
   val color: bool
end

module Implementation (Opts: Frules_options) =
struct

   open Coupling

   (* Classes with their members *)

   type f4_D =
      | D1 | D1bar | D2 | D2bar | D3 | D3bar
   type f3_U =
      | U1 | U1bar | U2 | U2bar | U3 | U3bar
   type f2_E =
      | E1 | E1bar | E2 | E2bar | E3 | E3bar
   type f1_Nu =
      | Nu1 | Nu2 | Nu3 | Nu4 | Nu5 | Nu6
   type s3_Hm =
      | Hm_1 | Hmc
   type s1_H =
      | H1 | H2
   type s2_Ah =
      | Ah1 | Ah2
   type v5_G =
      | G_1
   type v1_A =
      | A_1
   type v2_Z =
      | Z_1
   type v10_Zp =
      | Zp_1
   type v3_Wm =
      | Wm_1 | Wmc

   (* Lorentz types with the corresponding classes *)

   type scalar =
      | S3_Hm of s3_Hm | S1_H of s1_H | S2_Ah of s2_Ah
   type fermion =
      | F4_D of f4_D | F3_U of f3_U | F2_E of f2_E | F1_Nu of f1_Nu
   type vector =
      | V5_G of v5_G | V1_A of v1_A | V2_Z of v2_Z | V10_Zp of v10_Zp
      | V3_Wm of v3_Wm

   (* The actual flavor type *)

   type flavor =
      | FRS of scalar | FRF of fermion | FRV of vector

   (* Trampoline functions *)

   let fermion_of_f4_D c = F4_D c
   let fermion_of_f3_U c = F3_U c
   let fermion_of_f2_E c = F2_E c
   let fermion_of_f1_Nu c = F1_Nu c
   let scalar_of_s3_Hm c = S3_Hm c
   let scalar_of_s1_H c = S1_H c
   let scalar_of_s2_Ah c = S2_Ah c
   let vector_of_v5_G c = V5_G c
   let vector_of_v1_A c = V1_A c
   let vector_of_v2_Z c = V2_Z c
   let vector_of_v10_Zp c = V10_Zp c
   let vector_of_v3_Wm c = V3_Wm c
   let flavor_of_scalar lt = FRS lt
   let flavor_of_fermion lt = FRF lt
   let flavor_of_vector lt = FRV lt

   (* Particle lists *)

   let f4_D_members =
      [D1; D1bar; D2; D2bar; D3; D3bar;]
   let f3_U_members =
      [U1; U1bar; U2; U2bar; U3; U3bar;]
   let f2_E_members =
      [E1; E1bar; E2; E2bar; E3; E3bar;]
   let f1_Nu_members =
      [Nu1; Nu2; Nu3; Nu4; Nu5; Nu6;]
   let s3_Hm_members =
      [Hm_1; Hmc;]
   let s1_H_members =
      [H1; H2;]
   let s2_Ah_members =
      [Ah1; Ah2;]
   let v5_G_members =
      [G_1;]
   let v1_A_members =
      [A_1;]
   let v2_Z_members =
      [Z_1;]
   let v10_Zp_members =
      [Zp_1;]
   let v3_Wm_members =
      [Wm_1; Wmc;]
   let all_scalars = []
      @ (List.map scalar_of_s3_Hm s3_Hm_members)
      @ (List.map scalar_of_s1_H s1_H_members)
      @ (List.map scalar_of_s2_Ah s2_Ah_members)
   let all_fermions = []
      @ (List.map fermion_of_f4_D f4_D_members)
      @ (List.map fermion_of_f3_U f3_U_members)
      @ (List.map fermion_of_f2_E f2_E_members)
      @ (List.map fermion_of_f1_Nu f1_Nu_members)
   let all_vectors = []
      @ (List.map vector_of_v5_G v5_G_members)
      @ (List.map vector_of_v1_A v1_A_members)
      @ (List.map vector_of_v2_Z v2_Z_members)
      @ (List.map vector_of_v10_Zp v10_Zp_members)
      @ (List.map vector_of_v3_Wm v3_Wm_members)

   (* Orders *) 

   type orders = int * int 

   let orders = function  
       | _ -> (0,0) 


   (* The conjugation operation on a single class *)

   let conjugate_f4_D = function 
      | D1 -> D1bar | D1bar -> D1 | D2 -> D2bar | D2bar -> D2 | D3 -> D3bar
      | D3bar -> D3
   let conjugate_f3_U = function 
      | U1 -> U1bar | U1bar -> U1 | U2 -> U2bar | U2bar -> U2 | U3 -> U3bar
      | U3bar -> U3
   let conjugate_f2_E = function 
      | E1 -> E1bar | E1bar -> E1 | E2 -> E2bar | E2bar -> E2 | E3 -> E3bar
      | E3bar -> E3
   let conjugate_f1_Nu = function 
      | x -> x
   let conjugate_s3_Hm = function 
      | Hm_1 -> Hmc | Hmc -> Hm_1
   let conjugate_s1_H = function 
      | x -> x
   let conjugate_s2_Ah = function 
      | x -> x
   let conjugate_v5_G = function 
      | x -> x
   let conjugate_v1_A = function 
      | x -> x
   let conjugate_v2_Z = function 
      | x -> x
   let conjugate_v10_Zp = function 
      | x -> x
   let conjugate_v3_Wm = function 
      | Wm_1 -> Wmc | Wmc -> Wm_1

   (* The conjugation operation on a lorentz type *)

   let conjugate_scalar = function 
      | S3_Hm x -> S3_Hm (conjugate_s3_Hm x)
      | S1_H x -> S1_H (conjugate_s1_H x)
      | S2_Ah x -> S2_Ah (conjugate_s2_Ah x)
   let conjugate_fermion = function 
      | F4_D x -> F4_D (conjugate_f4_D x)
      | F3_U x -> F3_U (conjugate_f3_U x)
      | F2_E x -> F2_E (conjugate_f2_E x)
      | F1_Nu x -> F1_Nu (conjugate_f1_Nu x)
   let conjugate_vector = function 
      | V5_G x -> V5_G (conjugate_v5_G x)
      | V1_A x -> V1_A (conjugate_v1_A x)
      | V2_Z x -> V2_Z (conjugate_v2_Z x)
      | V10_Zp x -> V10_Zp (conjugate_v10_Zp x)
      | V3_Wm x -> V3_Wm (conjugate_v3_Wm x)

   (* Conjugation for the masses *)

   let conjugate = function
      | FRS x -> FRS (conjugate_scalar x)
      | FRF x -> FRF (conjugate_fermion x)
      | FRV x -> FRV (conjugate_vector x)

   let color = function
      | FRS _ -> Color.Singlet
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 | D2 | D3 -> Color.SUN 3 | D1bar | D2bar | D3bar -> Color.SUN (-3))

         | F3_U x -> (match x with 
            | U1 | U2 | U3 -> Color.SUN 3 | U1bar | U2bar | U3bar -> Color.SUN (-3))

         | F2_E _ -> Color.Singlet
         | F1_Nu _ -> Color.Singlet)
      | FRV x -> (match x with 
         | V5_G G_1 -> Color.AdjSUN 3
         | V1_A _ -> Color.Singlet
         | V2_Z _ -> Color.Singlet
         | V10_Zp _ -> Color.Singlet
         | V3_Wm _ -> Color.Singlet)

   let pdg = function
      | FRS x -> (match x with 
         | S3_Hm x -> (match x with 
            | Hm_1 -> 999900 | Hmc -> -999900)
         | S1_H x -> (match x with 
            | H1 -> 25 | H2 -> 35)
         | S2_Ah x -> (match x with 
            | Ah1 -> 999901 | Ah2 -> 999902))
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 -> 1 | D1bar -> -1 | D2 -> 3 | D2bar -> -3 | D3 -> 5 | D3bar -> -5)

         | F3_U x -> (match x with 
            | U1 -> 2 | U1bar -> -2 | U2 -> 4 | U2bar -> -4 | U3 -> 6 | U3bar -> -6)

         | F2_E x -> (match x with 
            | E1 -> 11 | E1bar -> -11 | E2 -> 13 | E2bar -> -13 | E3 -> 15 | E3bar -> -15)

         | F1_Nu x -> (match x with 
            | Nu1 -> 12 | Nu2 -> 14 | Nu3 -> 16 | Nu4 -> 8810012 | Nu5 -> 8810014
            | Nu6 -> 8810016))
      | FRV x -> (match x with 
         | V5_G G_1 -> 21
         | V1_A A_1 -> 22
         | V2_Z Z_1 -> 23
         | V10_Zp Zp_1 -> 31
         | V3_Wm x -> (match x with 
            | Wm_1 -> -24 | Wmc -> 24))

   let lorentz = function
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 | D2 | D3 -> Spinor | D1bar | D2bar | D3bar -> ConjSpinor)

         | F3_U x -> (match x with 
            | U1 | U2 | U3 -> Spinor | U1bar | U2bar | U3bar -> ConjSpinor)

         | F2_E x -> (match x with 
            | E1 | E2 | E3 -> Spinor | E1bar | E2bar | E3bar -> ConjSpinor)

         | F1_Nu x -> (match x with 
            | Nu1 | Nu2 | Nu3 | Nu4 | Nu5 | Nu6 -> Majorana))
      | FRV x -> (match x with 
         | V5_G G_1 -> Vector
         | V1_A A_1 -> Vector
         | V2_Z Z_1 -> Massive_Vector
         | V10_Zp Zp_1 -> Massive_Vector
         | V3_Wm x -> (match x with 
            | Wm_1 | Wmc -> Massive_Vector))
      | FRS _ -> Scalar

   type gauge = Xi

   let propagator = 
      let msg = "blsm_sarah.Implementation: invalid lorentz rep in propagator" in function
      | FRS _ -> Prop_Scalar
      | FRF x -> (match lorentz (FRF x) with
         | Spinor -> Prop_Spinor
         | ConjSpinor -> Prop_ConjSpinor
         | Majorana -> Prop_Majorana
         | _ -> invalid_arg msg)
      | FRV x -> (match Opts.gauge with
         | Unitarity -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Unitarity
            | _ -> invalid_arg msg)
         | Feynman -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg)
         | Rxi -> (match lorentz (FRV x) with
            | Vector -> Prop_Gauge Xi
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg))

   let width_symbol = function
      | FRS x -> (match x with 
         | S3_Hm _ -> "fr_zero"
         | S1_H x -> (match x with 
            | H1 -> "wh1" | H2 -> "wh2")
         | S2_Ah x -> (match x with 
            | Ah2 -> "wah2" | _ -> "fr_zero"))
      | FRF x -> (match x with 
         | F4_D _ -> "fr_zero"
         | F3_U x -> (match x with 
            | U3 -> "wu3" | U3bar -> "wu3" | _ -> "fr_zero")
         | F2_E _ -> "fr_zero"
         | F1_Nu x -> (match x with 
            | Nu4 -> "wnu4" | Nu5 -> "wnu5" | Nu6 -> "wnu6" | _ -> "fr_zero"))
      | FRV x -> (match x with 
         | V5_G _ -> "fr_zero"
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "wz"
         | V10_Zp Zp_1 -> "wzp"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "wwm" | Wmc -> "wwm"))

   let width x = match width_symbol x with 
      | "fr_zero" -> Vanishing
      | _ -> Timelike

   let fermion x = (match lorentz x with
      | Spinor -> 1 | ConjSpinor -> -1 | Majorana -> 2 | _ -> 0)

   let colsymm _ = (0, false), (0, false)

   let flavors () = []
      @ (List.map flavor_of_scalar all_scalars)
      @ (List.map flavor_of_fermion all_fermions)
      @ (List.map flavor_of_vector all_vectors)

   let external_flavors () = ["Autogenerated flavors", flavors ()]

   let goldstone _ = None

   let flavor_to_string = function
      | FRS x -> (match x with 
         | S3_Hm x -> (match x with 
            | Hm_1 -> "Hm" | Hmc -> "Hmc")
         | S1_H x -> (match x with 
            | H1 -> "h1" | H2 -> "h2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "Ah1" | Ah2 -> "Ah2"))
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 -> "d1" | D1bar -> "d1bar" | D2 -> "d2" | D2bar -> "d2bar" | D3 -> "d3"
            | D3bar -> "d3bar")
         | F3_U x -> (match x with 
            | U1 -> "u1" | U1bar -> "u1bar" | U2 -> "u2" | U2bar -> "u2bar" | U3 -> "u3"
            | U3bar -> "u3bar")
         | F2_E x -> (match x with 
            | E1 -> "e1" | E1bar -> "e1bar" | E2 -> "e2" | E2bar -> "e2bar" | E3 -> "e3"
            | E3bar -> "e3bar")
         | F1_Nu x -> (match x with 
            | Nu1 -> "nu1" | Nu2 -> "nu2" | Nu3 -> "nu3" | Nu4 -> "nu4" | Nu5 -> "nu5"
            | Nu6 -> "nu6"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g"
         | V1_A A_1 -> "A"
         | V2_Z Z_1 -> "Z"
         | V10_Zp Zp_1 -> "Zp"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "Wm" | Wmc -> "Wmc"))

   let flavor_to_TeX = function
      | FRS x -> (match x with 
         | S3_Hm x -> (match x with 
            | Hm_1 -> "H^-" | Hmc -> "H^-^*")
         | S1_H x -> (match x with 
            | H1 -> "{h}_1" | H2 -> "{h}_2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "{A_h}_1" | Ah2 -> "{A_h}_2"))
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 -> "{d}_1" | D1bar -> "{\\bar{d}}_1" | D2 -> "{d}_2"
            | D2bar -> "{\\bar{d}}_2" | D3 -> "{d}_3" | D3bar -> "{\\bar{d}}_3")

         | F3_U x -> (match x with 
            | U1 -> "{u}_1" | U1bar -> "{\\bar{u}}_1" | U2 -> "{u}_2"
            | U2bar -> "{\\bar{u}}_2" | U3 -> "{u}_3" | U3bar -> "{\\bar{u}}_3")

         | F2_E x -> (match x with 
            | E1 -> "{e}_1" | E1bar -> "{\\bar{e}}_1" | E2 -> "{e}_2"
            | E2bar -> "{\\bar{e}}_2" | E3 -> "{e}_3" | E3bar -> "{\\bar{e}}_3")

         | F1_Nu x -> (match x with 
            | Nu1 -> "{\\nu}_1" | Nu2 -> "{\\nu}_2" | Nu3 -> "{\\nu}_3" | Nu4 -> "{\\nu}_4"
            | Nu5 -> "{\\nu}_5" | Nu6 -> "{\\nu}_6"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g"
         | V1_A A_1 -> "\\gamma"
         | V2_Z Z_1 -> "Z"
         | V10_Zp Zp_1 -> "{Z'}"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "W^-" | Wmc -> "W^+"))

   let flavor_of_string x =
      let dict = List.map (fun x -> (x, flavor_to_string x)) (flavors ())
      in try
         fst (List.find (fun (_, y) -> (x = y)) dict)
      with
         Not_found -> invalid_arg "blsm_sarah.Implementation: flavor_of_string: invalid particle?"

   let flavor_symbol = function
      | FRS x -> (match x with 
         | S3_Hm x -> (match x with 
            | Hm_1 -> "hm_1" | Hmc -> "hmc")
         | S1_H x -> (match x with 
            | H1 -> "h1" | H2 -> "h2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "ah1" | Ah2 -> "ah2"))
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 -> "d1" | D1bar -> "d1bar" | D2 -> "d2" | D2bar -> "d2bar" | D3 -> "d3"
            | D3bar -> "d3bar")
         | F3_U x -> (match x with 
            | U1 -> "u1" | U1bar -> "u1bar" | U2 -> "u2" | U2bar -> "u2bar" | U3 -> "u3"
            | U3bar -> "u3bar")
         | F2_E x -> (match x with 
            | E1 -> "e1" | E1bar -> "e1bar" | E2 -> "e2" | E2bar -> "e2bar" | E3 -> "e3"
            | E3bar -> "e3bar")
         | F1_Nu x -> (match x with 
            | Nu1 -> "nu1" | Nu2 -> "nu2" | Nu3 -> "nu3" | Nu4 -> "nu4" | Nu5 -> "nu5"
            | Nu6 -> "nu6"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g_1"
         | V1_A A_1 -> "a_1"
         | V2_Z Z_1 -> "z_1"
         | V10_Zp Zp_1 -> "zp_1"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "wm_1" | Wmc -> "wmc"))

   let gauge_symbol = function
      Xi -> (match Opts.gauge with
         | Unitarity -> invalid_arg
            "blsm_sarah.Implementation: requesting gauge symbol in unitarity gauge!"
         | Feynman -> "one"
         | Rxi -> "Rxi")

   let mass_symbol = function
      | FRS x -> (match x with 
         | S3_Hm x -> (match x with 
            | Hm_1 -> "mhm" | Hmc -> "mhm")
         | S1_H x -> (match x with 
            | H1 -> "mh1" | H2 -> "mh2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "mah1" | Ah2 -> "mah2"))
      | FRF x -> (match x with 
         | F4_D x -> (match x with 
            | D1 -> "md1" | D1bar -> "md1" | D2 -> "md2" | D2bar -> "md2" | D3 -> "md3"
            | D3bar -> "md3")
         | F3_U x -> (match x with 
            | U1 -> "mu1" | U1bar -> "mu1" | U2 -> "mu2" | U2bar -> "mu2" | U3 -> "mu3"
            | U3bar -> "mu3")
         | F2_E x -> (match x with 
            | E1 -> "me1" | E1bar -> "me1" | E2 -> "me2" | E2bar -> "me2" | E3 -> "me3"
            | E3bar -> "me3")
         | F1_Nu x -> (match x with 
            | Nu4 -> "mnu4" | Nu5 -> "mnu5" | Nu6 -> "mnu6" | _ -> "fr_zero"))
      | FRV x -> (match x with 
         | V5_G _ -> "fr_zero"
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "mz"
         | V10_Zp Zp_1 -> "mzp"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "mwm" | Wmc -> "mwm"))

   (* Coupling constants and parameters *)

   type constant =
      | G_h1_h1_h1 | G_h1_h1_h2 | G_h1_h2_h2 | G_h2_h2_h2 | G_h1_h1_a_1_a_1
      | G_h1_h2_a_1_a_1 | G_h2_h2_a_1_a_1 | G_h1_h1_a_1_z_1 | G_h1_h2_a_1_z_1
      | G_h2_h2_a_1_z_1 | G_h1_h1_a_1_zp_1 | G_h1_h2_a_1_zp_1 | G_h2_h2_a_1_zp_1
      | G_h1_h1_wmc_wm_1 | G_h1_h2_wmc_wm_1 | G_h2_h2_wmc_wm_1 | G_h1_h1_z_1_z_1
      | G_h1_h2_z_1_z_1 | G_h2_h2_z_1_z_1 | G_h1_h1_z_1_zp_1 | G_h1_h2_z_1_zp_1
      | G_h2_h2_z_1_zp_1 | G_h1_h1_zp_1_zp_1 | G_h1_h2_zp_1_zp_1 | G_h2_h2_zp_1_zp_1
      | G_h1_a_1_a_1 | G_h2_a_1_a_1 | G_h1_a_1_z_1 | G_h2_a_1_z_1 | G_h1_a_1_zp_1
      | G_h2_a_1_zp_1 | G_h1_wmc_wm_1 | G_h2_wmc_wm_1 | G_h1_z_1_z_1 | G_h2_z_1_z_1
      | G_h1_z_1_zp_1 | G_h2_z_1_zp_1 | G_h1_zp_1_zp_1 | G_h2_zp_1_zp_1
      | G_d1bar_h1_d1 | G_d1bar_h2_d1 | G_d1bar_h1_d2 | G_d1bar_h2_d2 | G_d1bar_h1_d3
      | G_d1bar_h2_d3 | G_d2bar_h1_d1 | G_d2bar_h2_d1 | G_d2bar_h1_d2 | G_d2bar_h2_d2
      | G_d2bar_h1_d3 | G_d2bar_h2_d3 | G_d3bar_h1_d1 | G_d3bar_h2_d1 | G_d3bar_h1_d2
      | G_d3bar_h2_d2 | G_d3bar_h1_d3 | G_d3bar_h2_d3 | G_e1bar_h1_e1 | G_e1bar_h2_e1
      | G_e1bar_h1_e2 | G_e1bar_h2_e2 | G_e1bar_h1_e3 | G_e1bar_h2_e3 | G_e2bar_h1_e1
      | G_e2bar_h2_e1 | G_e2bar_h1_e2 | G_e2bar_h2_e2 | G_e2bar_h1_e3 | G_e2bar_h2_e3
      | G_e3bar_h1_e1 | G_e3bar_h2_e1 | G_e3bar_h1_e2 | G_e3bar_h2_e2 | G_e3bar_h1_e3
      | G_e3bar_h2_e3 | G_u1bar_h1_u1 | G_u1bar_h2_u1 | G_u1bar_h1_u2 | G_u1bar_h2_u2
      | G_u1bar_h1_u3 | G_u1bar_h2_u3 | G_u2bar_h1_u1 | G_u2bar_h2_u1 | G_u2bar_h1_u2
      | G_u2bar_h2_u2 | G_u2bar_h1_u3 | G_u2bar_h2_u3 | G_u3bar_h1_u1 | G_u3bar_h2_u1
      | G_u3bar_h1_u2 | G_u3bar_h2_u2 | G_u3bar_h1_u3 | G_u3bar_h2_u3 | G_nu1_h1_nu1
      | G_nu1_h2_nu1 | G_nu1_h1_nu2 | G_nu1_h2_nu2 | G_nu1_h1_nu3 | G_nu1_h2_nu3
      | G_nu1_h1_nu4 | G_nu1_h2_nu4 | G_nu1_h1_nu5 | G_nu1_h2_nu5 | G_nu1_h1_nu6
      | G_nu1_h2_nu6 | G_nu2_h1_nu2 | G_nu2_h2_nu2 | G_nu2_h1_nu3 | G_nu2_h2_nu3
      | G_nu2_h1_nu4 | G_nu2_h2_nu4 | G_nu2_h1_nu5 | G_nu2_h2_nu5 | G_nu2_h1_nu6
      | G_nu2_h2_nu6 | G_nu3_h1_nu3 | G_nu3_h2_nu3 | G_nu3_h1_nu4 | G_nu3_h2_nu4
      | G_nu3_h1_nu5 | G_nu3_h2_nu5 | G_nu3_h1_nu6 | G_nu3_h2_nu6 | G_nu4_h1_nu4
      | G_nu4_h2_nu4 | G_nu4_h1_nu5 | G_nu4_h2_nu5 | G_nu4_h1_nu6 | G_nu4_h2_nu6
      | G_nu5_h1_nu5 | G_nu5_h2_nu5 | G_nu5_h1_nu6 | G_nu5_h2_nu6 | G_nu6_h1_nu6
      | G_nu6_h2_nu6 | G_d1bar_g_1_d1 | G_d1bar_a_1_d1 | G_d1bar_z_1_d1
      | G_d1bar_zp_1_d1 | G_u1bar_wmc_d1 | G_u1bar_wmc_d2 | G_u1bar_wmc_d3
      | G_u2bar_wmc_d1 | G_u2bar_wmc_d2 | G_u2bar_wmc_d3 | G_u3bar_wmc_d1
      | G_u3bar_wmc_d2 | G_u3bar_wmc_d3 | G_nu1_wmc_e1 | G_nu1_wmc_e2 | G_nu1_wmc_e3
      | G_nu2_wmc_e1 | G_nu2_wmc_e2 | G_nu2_wmc_e3 | G_nu3_wmc_e1 | G_nu3_wmc_e2
      | G_nu3_wmc_e3 | G_nu4_wmc_e1 | G_nu4_wmc_e2 | G_nu4_wmc_e3 | G_nu5_wmc_e1
      | G_nu5_wmc_e2 | G_nu5_wmc_e3 | G_nu6_wmc_e1 | G_nu6_wmc_e2 | G_nu6_wmc_e3
      | G_e1bar_a_1_e1 | G_e1bar_z_1_e1 | G_e1bar_zp_1_e1 | G_u1bar_a_1_u1
      | G_d1bar_wm_1_u1 | G_d1bar_wm_1_u2 | G_d1bar_wm_1_u3 | G_d2bar_wm_1_u1
      | G_d2bar_wm_1_u2 | G_d2bar_wm_1_u3 | G_d3bar_wm_1_u1 | G_d3bar_wm_1_u2
      | G_d3bar_wm_1_u3 | G_u1bar_z_1_u1 | G_u1bar_zp_1_u1 | G_nu1_a_1_nu1
      | G_nu1_a_1_nu2 | G_nu1_a_1_nu3 | G_nu1_a_1_nu4 | G_nu1_a_1_nu5 | G_nu1_a_1_nu6
      | G_nu2_a_1_nu2 | G_nu2_a_1_nu3 | G_nu2_a_1_nu4 | G_nu2_a_1_nu5 | G_nu2_a_1_nu6
      | G_nu3_a_1_nu3 | G_nu3_a_1_nu4 | G_nu3_a_1_nu5 | G_nu3_a_1_nu6 | G_nu4_a_1_nu4
      | G_nu4_a_1_nu5 | G_nu4_a_1_nu6 | G_nu5_a_1_nu5 | G_nu5_a_1_nu6 | G_nu6_a_1_nu6
      | G_nu1_z_1_nu1 | G_nu1_z_1_nu2 | G_nu1_z_1_nu3 | G_nu1_z_1_nu4 | G_nu1_z_1_nu5
      | G_nu1_z_1_nu6 | G_nu2_z_1_nu2 | G_nu2_z_1_nu3 | G_nu2_z_1_nu4 | G_nu2_z_1_nu5
      | G_nu2_z_1_nu6 | G_nu3_z_1_nu3 | G_nu3_z_1_nu4 | G_nu3_z_1_nu5 | G_nu3_z_1_nu6
      | G_nu4_z_1_nu4 | G_nu4_z_1_nu5 | G_nu4_z_1_nu6 | G_nu5_z_1_nu5 | G_nu5_z_1_nu6
      | G_nu6_z_1_nu6 | G_nu1_zp_1_nu1 | G_nu1_zp_1_nu2 | G_nu1_zp_1_nu3
      | G_nu1_zp_1_nu4 | G_nu1_zp_1_nu5 | G_nu1_zp_1_nu6 | G_nu2_zp_1_nu2
      | G_nu2_zp_1_nu3 | G_nu2_zp_1_nu4 | G_nu2_zp_1_nu5 | G_nu2_zp_1_nu6
      | G_nu3_zp_1_nu3 | G_nu3_zp_1_nu4 | G_nu3_zp_1_nu5 | G_nu3_zp_1_nu6
      | G_nu4_zp_1_nu4 | G_nu4_zp_1_nu5 | G_nu4_zp_1_nu6 | G_nu5_zp_1_nu5
      | G_nu5_zp_1_nu6 | G_nu6_zp_1_nu6 | G_e1bar_wm_1_nu1 | G_e1bar_wm_1_nu2
      | G_e1bar_wm_1_nu3 | G_e1bar_wm_1_nu4 | G_e1bar_wm_1_nu5 | G_e1bar_wm_1_nu6
      | G_e2bar_wm_1_nu1 | G_e2bar_wm_1_nu2 | G_e2bar_wm_1_nu3 | G_e2bar_wm_1_nu4
      | G_e2bar_wm_1_nu5 | G_e2bar_wm_1_nu6 | G_e3bar_wm_1_nu1 | G_e3bar_wm_1_nu2
      | G_e3bar_wm_1_nu3 | G_e3bar_wm_1_nu4 | G_e3bar_wm_1_nu5 | G_e3bar_wm_1_nu6
      | G_g_1_g_1_g_1 | G_wmc_a_1_wm_1 | G_wmc_wm_1_z_1 | G_wmc_wm_1_zp_1
      | G_g_1_g_1_g_1_g_1 | G_wmc_a_1_a_1_wm_1 | G_wmc_a_1_wm_1_z_1
      | G_wmc_a_1_wm_1_z_1_1 | G_wmc_a_1_wm_1_zp_1 | G_wmc_a_1_wm_1_zp_1_1
      | G_wmc_wmc_wm_1_wm_1 | G_wmc_wm_1_z_1_z_1 | G_wmc_wm_1_z_1_zp_1
      | G_wmc_wm_1_z_1_zp_1_1 | G_wmc_wm_1_zp_1_zp_1

   let parameters () = {input = []; derived = []; derived_arrays = []}

   let constant_symbol = function
      | G_h1_h1_h1 -> "G_h1_h1_h1" | G_h1_h1_h2 -> "G_h1_h1_h2"
      | G_h1_h2_h2 -> "G_h1_h2_h2" | G_h2_h2_h2 -> "G_h2_h2_h2"
      | G_h1_h1_a_1_a_1 -> "G_h1_h1_a_1_a_1" | G_h1_h2_a_1_a_1 -> "G_h1_h2_a_1_a_1"
      | G_h2_h2_a_1_a_1 -> "G_h2_h2_a_1_a_1" | G_h1_h1_a_1_z_1 -> "G_h1_h1_a_1_z_1"
      | G_h1_h2_a_1_z_1 -> "G_h1_h2_a_1_z_1" | G_h2_h2_a_1_z_1 -> "G_h2_h2_a_1_z_1"
      | G_h1_h1_a_1_zp_1 -> "G_h1_h1_a_1_zp_1"
      | G_h1_h2_a_1_zp_1 -> "G_h1_h2_a_1_zp_1"
      | G_h2_h2_a_1_zp_1 -> "G_h2_h2_a_1_zp_1"
      | G_h1_h1_wmc_wm_1 -> "G_h1_h1_wmc_wm_1"
      | G_h1_h2_wmc_wm_1 -> "G_h1_h2_wmc_wm_1"
      | G_h2_h2_wmc_wm_1 -> "G_h2_h2_wmc_wm_1" | G_h1_h1_z_1_z_1 -> "G_h1_h1_z_1_z_1"
      | G_h1_h2_z_1_z_1 -> "G_h1_h2_z_1_z_1" | G_h2_h2_z_1_z_1 -> "G_h2_h2_z_1_z_1"
      | G_h1_h1_z_1_zp_1 -> "G_h1_h1_z_1_zp_1"
      | G_h1_h2_z_1_zp_1 -> "G_h1_h2_z_1_zp_1"
      | G_h2_h2_z_1_zp_1 -> "G_h2_h2_z_1_zp_1"
      | G_h1_h1_zp_1_zp_1 -> "G_h1_h1_zp_1_zp_1"
      | G_h1_h2_zp_1_zp_1 -> "G_h1_h2_zp_1_zp_1"
      | G_h2_h2_zp_1_zp_1 -> "G_h2_h2_zp_1_zp_1" | G_h1_a_1_a_1 -> "G_h1_a_1_a_1"
      | G_h2_a_1_a_1 -> "G_h2_a_1_a_1" | G_h1_a_1_z_1 -> "G_h1_a_1_z_1"
      | G_h2_a_1_z_1 -> "G_h2_a_1_z_1" | G_h1_a_1_zp_1 -> "G_h1_a_1_zp_1"
      | G_h2_a_1_zp_1 -> "G_h2_a_1_zp_1" | G_h1_wmc_wm_1 -> "G_h1_wmc_wm_1"
      | G_h2_wmc_wm_1 -> "G_h2_wmc_wm_1" | G_h1_z_1_z_1 -> "G_h1_z_1_z_1"
      | G_h2_z_1_z_1 -> "G_h2_z_1_z_1" | G_h1_z_1_zp_1 -> "G_h1_z_1_zp_1"
      | G_h2_z_1_zp_1 -> "G_h2_z_1_zp_1" | G_h1_zp_1_zp_1 -> "G_h1_zp_1_zp_1"
      | G_h2_zp_1_zp_1 -> "G_h2_zp_1_zp_1" | G_d1bar_h1_d1 -> "G_d1bar_h1_d1"
      | G_d1bar_h2_d1 -> "G_d1bar_h2_d1" | G_d1bar_h1_d2 -> "G_d1bar_h1_d2"
      | G_d1bar_h2_d2 -> "G_d1bar_h2_d2" | G_d1bar_h1_d3 -> "G_d1bar_h1_d3"
      | G_d1bar_h2_d3 -> "G_d1bar_h2_d3" | G_d2bar_h1_d1 -> "G_d2bar_h1_d1"
      | G_d2bar_h2_d1 -> "G_d2bar_h2_d1" | G_d2bar_h1_d2 -> "G_d2bar_h1_d2"
      | G_d2bar_h2_d2 -> "G_d2bar_h2_d2" | G_d2bar_h1_d3 -> "G_d2bar_h1_d3"
      | G_d2bar_h2_d3 -> "G_d2bar_h2_d3" | G_d3bar_h1_d1 -> "G_d3bar_h1_d1"
      | G_d3bar_h2_d1 -> "G_d3bar_h2_d1" | G_d3bar_h1_d2 -> "G_d3bar_h1_d2"
      | G_d3bar_h2_d2 -> "G_d3bar_h2_d2" | G_d3bar_h1_d3 -> "G_d3bar_h1_d3"
      | G_d3bar_h2_d3 -> "G_d3bar_h2_d3" | G_e1bar_h1_e1 -> "G_e1bar_h1_e1"
      | G_e1bar_h2_e1 -> "G_e1bar_h2_e1" | G_e1bar_h1_e2 -> "G_e1bar_h1_e2"
      | G_e1bar_h2_e2 -> "G_e1bar_h2_e2" | G_e1bar_h1_e3 -> "G_e1bar_h1_e3"
      | G_e1bar_h2_e3 -> "G_e1bar_h2_e3" | G_e2bar_h1_e1 -> "G_e2bar_h1_e1"
      | G_e2bar_h2_e1 -> "G_e2bar_h2_e1" | G_e2bar_h1_e2 -> "G_e2bar_h1_e2"
      | G_e2bar_h2_e2 -> "G_e2bar_h2_e2" | G_e2bar_h1_e3 -> "G_e2bar_h1_e3"
      | G_e2bar_h2_e3 -> "G_e2bar_h2_e3" | G_e3bar_h1_e1 -> "G_e3bar_h1_e1"
      | G_e3bar_h2_e1 -> "G_e3bar_h2_e1" | G_e3bar_h1_e2 -> "G_e3bar_h1_e2"
      | G_e3bar_h2_e2 -> "G_e3bar_h2_e2" | G_e3bar_h1_e3 -> "G_e3bar_h1_e3"
      | G_e3bar_h2_e3 -> "G_e3bar_h2_e3" | G_u1bar_h1_u1 -> "G_u1bar_h1_u1"
      | G_u1bar_h2_u1 -> "G_u1bar_h2_u1" | G_u1bar_h1_u2 -> "G_u1bar_h1_u2"
      | G_u1bar_h2_u2 -> "G_u1bar_h2_u2" | G_u1bar_h1_u3 -> "G_u1bar_h1_u3"
      | G_u1bar_h2_u3 -> "G_u1bar_h2_u3" | G_u2bar_h1_u1 -> "G_u2bar_h1_u1"
      | G_u2bar_h2_u1 -> "G_u2bar_h2_u1" | G_u2bar_h1_u2 -> "G_u2bar_h1_u2"
      | G_u2bar_h2_u2 -> "G_u2bar_h2_u2" | G_u2bar_h1_u3 -> "G_u2bar_h1_u3"
      | G_u2bar_h2_u3 -> "G_u2bar_h2_u3" | G_u3bar_h1_u1 -> "G_u3bar_h1_u1"
      | G_u3bar_h2_u1 -> "G_u3bar_h2_u1" | G_u3bar_h1_u2 -> "G_u3bar_h1_u2"
      | G_u3bar_h2_u2 -> "G_u3bar_h2_u2" | G_u3bar_h1_u3 -> "G_u3bar_h1_u3"
      | G_u3bar_h2_u3 -> "G_u3bar_h2_u3" | G_nu1_h1_nu1 -> "G_nu1_h1_nu1"
      | G_nu1_h2_nu1 -> "G_nu1_h2_nu1" | G_nu1_h1_nu2 -> "G_nu1_h1_nu2"
      | G_nu1_h2_nu2 -> "G_nu1_h2_nu2" | G_nu1_h1_nu3 -> "G_nu1_h1_nu3"
      | G_nu1_h2_nu3 -> "G_nu1_h2_nu3" | G_nu1_h1_nu4 -> "G_nu1_h1_nu4"
      | G_nu1_h2_nu4 -> "G_nu1_h2_nu4" | G_nu1_h1_nu5 -> "G_nu1_h1_nu5"
      | G_nu1_h2_nu5 -> "G_nu1_h2_nu5" | G_nu1_h1_nu6 -> "G_nu1_h1_nu6"
      | G_nu1_h2_nu6 -> "G_nu1_h2_nu6" | G_nu2_h1_nu2 -> "G_nu2_h1_nu2"
      | G_nu2_h2_nu2 -> "G_nu2_h2_nu2" | G_nu2_h1_nu3 -> "G_nu2_h1_nu3"
      | G_nu2_h2_nu3 -> "G_nu2_h2_nu3" | G_nu2_h1_nu4 -> "G_nu2_h1_nu4"
      | G_nu2_h2_nu4 -> "G_nu2_h2_nu4" | G_nu2_h1_nu5 -> "G_nu2_h1_nu5"
      | G_nu2_h2_nu5 -> "G_nu2_h2_nu5" | G_nu2_h1_nu6 -> "G_nu2_h1_nu6"
      | G_nu2_h2_nu6 -> "G_nu2_h2_nu6" | G_nu3_h1_nu3 -> "G_nu3_h1_nu3"
      | G_nu3_h2_nu3 -> "G_nu3_h2_nu3" | G_nu3_h1_nu4 -> "G_nu3_h1_nu4"
      | G_nu3_h2_nu4 -> "G_nu3_h2_nu4" | G_nu3_h1_nu5 -> "G_nu3_h1_nu5"
      | G_nu3_h2_nu5 -> "G_nu3_h2_nu5" | G_nu3_h1_nu6 -> "G_nu3_h1_nu6"
      | G_nu3_h2_nu6 -> "G_nu3_h2_nu6" | G_nu4_h1_nu4 -> "G_nu4_h1_nu4"
      | G_nu4_h2_nu4 -> "G_nu4_h2_nu4" | G_nu4_h1_nu5 -> "G_nu4_h1_nu5"
      | G_nu4_h2_nu5 -> "G_nu4_h2_nu5" | G_nu4_h1_nu6 -> "G_nu4_h1_nu6"
      | G_nu4_h2_nu6 -> "G_nu4_h2_nu6" | G_nu5_h1_nu5 -> "G_nu5_h1_nu5"
      | G_nu5_h2_nu5 -> "G_nu5_h2_nu5" | G_nu5_h1_nu6 -> "G_nu5_h1_nu6"
      | G_nu5_h2_nu6 -> "G_nu5_h2_nu6" | G_nu6_h1_nu6 -> "G_nu6_h1_nu6"
      | G_nu6_h2_nu6 -> "G_nu6_h2_nu6" | G_d1bar_g_1_d1 -> "G_d1bar_g_1_d1"
      | G_d1bar_a_1_d1 -> "G_d1bar_a_1_d1" | G_d1bar_z_1_d1 -> "G_d1bar_z_1_d1"
      | G_d1bar_zp_1_d1 -> "G_d1bar_zp_1_d1" | G_u1bar_wmc_d1 -> "G_u1bar_wmc_d1"
      | G_u1bar_wmc_d2 -> "G_u1bar_wmc_d2" | G_u1bar_wmc_d3 -> "G_u1bar_wmc_d3"
      | G_u2bar_wmc_d1 -> "G_u2bar_wmc_d1" | G_u2bar_wmc_d2 -> "G_u2bar_wmc_d2"
      | G_u2bar_wmc_d3 -> "G_u2bar_wmc_d3" | G_u3bar_wmc_d1 -> "G_u3bar_wmc_d1"
      | G_u3bar_wmc_d2 -> "G_u3bar_wmc_d2" | G_u3bar_wmc_d3 -> "G_u3bar_wmc_d3"
      | G_nu1_wmc_e1 -> "G_nu1_wmc_e1" | G_nu1_wmc_e2 -> "G_nu1_wmc_e2"
      | G_nu1_wmc_e3 -> "G_nu1_wmc_e3" | G_nu2_wmc_e1 -> "G_nu2_wmc_e1"
      | G_nu2_wmc_e2 -> "G_nu2_wmc_e2" | G_nu2_wmc_e3 -> "G_nu2_wmc_e3"
      | G_nu3_wmc_e1 -> "G_nu3_wmc_e1" | G_nu3_wmc_e2 -> "G_nu3_wmc_e2"
      | G_nu3_wmc_e3 -> "G_nu3_wmc_e3" | G_nu4_wmc_e1 -> "G_nu4_wmc_e1"
      | G_nu4_wmc_e2 -> "G_nu4_wmc_e2" | G_nu4_wmc_e3 -> "G_nu4_wmc_e3"
      | G_nu5_wmc_e1 -> "G_nu5_wmc_e1" | G_nu5_wmc_e2 -> "G_nu5_wmc_e2"
      | G_nu5_wmc_e3 -> "G_nu5_wmc_e3" | G_nu6_wmc_e1 -> "G_nu6_wmc_e1"
      | G_nu6_wmc_e2 -> "G_nu6_wmc_e2" | G_nu6_wmc_e3 -> "G_nu6_wmc_e3"
      | G_e1bar_a_1_e1 -> "G_e1bar_a_1_e1" | G_e1bar_z_1_e1 -> "G_e1bar_z_1_e1"
      | G_e1bar_zp_1_e1 -> "G_e1bar_zp_1_e1" | G_u1bar_a_1_u1 -> "G_u1bar_a_1_u1"
      | G_d1bar_wm_1_u1 -> "G_d1bar_wm_1_u1" | G_d1bar_wm_1_u2 -> "G_d1bar_wm_1_u2"
      | G_d1bar_wm_1_u3 -> "G_d1bar_wm_1_u3" | G_d2bar_wm_1_u1 -> "G_d2bar_wm_1_u1"
      | G_d2bar_wm_1_u2 -> "G_d2bar_wm_1_u2" | G_d2bar_wm_1_u3 -> "G_d2bar_wm_1_u3"
      | G_d3bar_wm_1_u1 -> "G_d3bar_wm_1_u1" | G_d3bar_wm_1_u2 -> "G_d3bar_wm_1_u2"
      | G_d3bar_wm_1_u3 -> "G_d3bar_wm_1_u3" | G_u1bar_z_1_u1 -> "G_u1bar_z_1_u1"
      | G_u1bar_zp_1_u1 -> "G_u1bar_zp_1_u1" | G_nu1_a_1_nu1 -> "G_nu1_a_1_nu1"
      | G_nu1_a_1_nu2 -> "G_nu1_a_1_nu2" | G_nu1_a_1_nu3 -> "G_nu1_a_1_nu3"
      | G_nu1_a_1_nu4 -> "G_nu1_a_1_nu4" | G_nu1_a_1_nu5 -> "G_nu1_a_1_nu5"
      | G_nu1_a_1_nu6 -> "G_nu1_a_1_nu6" | G_nu2_a_1_nu2 -> "G_nu2_a_1_nu2"
      | G_nu2_a_1_nu3 -> "G_nu2_a_1_nu3" | G_nu2_a_1_nu4 -> "G_nu2_a_1_nu4"
      | G_nu2_a_1_nu5 -> "G_nu2_a_1_nu5" | G_nu2_a_1_nu6 -> "G_nu2_a_1_nu6"
      | G_nu3_a_1_nu3 -> "G_nu3_a_1_nu3" | G_nu3_a_1_nu4 -> "G_nu3_a_1_nu4"
      | G_nu3_a_1_nu5 -> "G_nu3_a_1_nu5" | G_nu3_a_1_nu6 -> "G_nu3_a_1_nu6"
      | G_nu4_a_1_nu4 -> "G_nu4_a_1_nu4" | G_nu4_a_1_nu5 -> "G_nu4_a_1_nu5"
      | G_nu4_a_1_nu6 -> "G_nu4_a_1_nu6" | G_nu5_a_1_nu5 -> "G_nu5_a_1_nu5"
      | G_nu5_a_1_nu6 -> "G_nu5_a_1_nu6" | G_nu6_a_1_nu6 -> "G_nu6_a_1_nu6"
      | G_nu1_z_1_nu1 -> "G_nu1_z_1_nu1" | G_nu1_z_1_nu2 -> "G_nu1_z_1_nu2"
      | G_nu1_z_1_nu3 -> "G_nu1_z_1_nu3" | G_nu1_z_1_nu4 -> "G_nu1_z_1_nu4"
      | G_nu1_z_1_nu5 -> "G_nu1_z_1_nu5" | G_nu1_z_1_nu6 -> "G_nu1_z_1_nu6"
      | G_nu2_z_1_nu2 -> "G_nu2_z_1_nu2" | G_nu2_z_1_nu3 -> "G_nu2_z_1_nu3"
      | G_nu2_z_1_nu4 -> "G_nu2_z_1_nu4" | G_nu2_z_1_nu5 -> "G_nu2_z_1_nu5"
      | G_nu2_z_1_nu6 -> "G_nu2_z_1_nu6" | G_nu3_z_1_nu3 -> "G_nu3_z_1_nu3"
      | G_nu3_z_1_nu4 -> "G_nu3_z_1_nu4" | G_nu3_z_1_nu5 -> "G_nu3_z_1_nu5"
      | G_nu3_z_1_nu6 -> "G_nu3_z_1_nu6" | G_nu4_z_1_nu4 -> "G_nu4_z_1_nu4"
      | G_nu4_z_1_nu5 -> "G_nu4_z_1_nu5" | G_nu4_z_1_nu6 -> "G_nu4_z_1_nu6"
      | G_nu5_z_1_nu5 -> "G_nu5_z_1_nu5" | G_nu5_z_1_nu6 -> "G_nu5_z_1_nu6"
      | G_nu6_z_1_nu6 -> "G_nu6_z_1_nu6" | G_nu1_zp_1_nu1 -> "G_nu1_zp_1_nu1"
      | G_nu1_zp_1_nu2 -> "G_nu1_zp_1_nu2" | G_nu1_zp_1_nu3 -> "G_nu1_zp_1_nu3"
      | G_nu1_zp_1_nu4 -> "G_nu1_zp_1_nu4" | G_nu1_zp_1_nu5 -> "G_nu1_zp_1_nu5"
      | G_nu1_zp_1_nu6 -> "G_nu1_zp_1_nu6" | G_nu2_zp_1_nu2 -> "G_nu2_zp_1_nu2"
      | G_nu2_zp_1_nu3 -> "G_nu2_zp_1_nu3" | G_nu2_zp_1_nu4 -> "G_nu2_zp_1_nu4"
      | G_nu2_zp_1_nu5 -> "G_nu2_zp_1_nu5" | G_nu2_zp_1_nu6 -> "G_nu2_zp_1_nu6"
      | G_nu3_zp_1_nu3 -> "G_nu3_zp_1_nu3" | G_nu3_zp_1_nu4 -> "G_nu3_zp_1_nu4"
      | G_nu3_zp_1_nu5 -> "G_nu3_zp_1_nu5" | G_nu3_zp_1_nu6 -> "G_nu3_zp_1_nu6"
      | G_nu4_zp_1_nu4 -> "G_nu4_zp_1_nu4" | G_nu4_zp_1_nu5 -> "G_nu4_zp_1_nu5"
      | G_nu4_zp_1_nu6 -> "G_nu4_zp_1_nu6" | G_nu5_zp_1_nu5 -> "G_nu5_zp_1_nu5"
      | G_nu5_zp_1_nu6 -> "G_nu5_zp_1_nu6" | G_nu6_zp_1_nu6 -> "G_nu6_zp_1_nu6"
      | G_e1bar_wm_1_nu1 -> "G_e1bar_wm_1_nu1"
      | G_e1bar_wm_1_nu2 -> "G_e1bar_wm_1_nu2"
      | G_e1bar_wm_1_nu3 -> "G_e1bar_wm_1_nu3"
      | G_e1bar_wm_1_nu4 -> "G_e1bar_wm_1_nu4"
      | G_e1bar_wm_1_nu5 -> "G_e1bar_wm_1_nu5"
      | G_e1bar_wm_1_nu6 -> "G_e1bar_wm_1_nu6"
      | G_e2bar_wm_1_nu1 -> "G_e2bar_wm_1_nu1"
      | G_e2bar_wm_1_nu2 -> "G_e2bar_wm_1_nu2"
      | G_e2bar_wm_1_nu3 -> "G_e2bar_wm_1_nu3"
      | G_e2bar_wm_1_nu4 -> "G_e2bar_wm_1_nu4"
      | G_e2bar_wm_1_nu5 -> "G_e2bar_wm_1_nu5"
      | G_e2bar_wm_1_nu6 -> "G_e2bar_wm_1_nu6"
      | G_e3bar_wm_1_nu1 -> "G_e3bar_wm_1_nu1"
      | G_e3bar_wm_1_nu2 -> "G_e3bar_wm_1_nu2"
      | G_e3bar_wm_1_nu3 -> "G_e3bar_wm_1_nu3"
      | G_e3bar_wm_1_nu4 -> "G_e3bar_wm_1_nu4"
      | G_e3bar_wm_1_nu5 -> "G_e3bar_wm_1_nu5"
      | G_e3bar_wm_1_nu6 -> "G_e3bar_wm_1_nu6" | G_g_1_g_1_g_1 -> "G_g_1_g_1_g_1"
      | G_wmc_a_1_wm_1 -> "G_wmc_a_1_wm_1" | G_wmc_wm_1_z_1 -> "G_wmc_wm_1_z_1"
      | G_wmc_wm_1_zp_1 -> "G_wmc_wm_1_zp_1"
      | G_g_1_g_1_g_1_g_1 -> "G_g_1_g_1_g_1_g_1"
      | G_wmc_a_1_a_1_wm_1 -> "G_wmc_a_1_a_1_wm_1"
      | G_wmc_a_1_wm_1_z_1 -> "G_wmc_a_1_wm_1_z_1"
      | G_wmc_a_1_wm_1_z_1_1 -> "G_wmc_a_1_wm_1_z_1_1"
      | G_wmc_a_1_wm_1_zp_1 -> "G_wmc_a_1_wm_1_zp_1"
      | G_wmc_a_1_wm_1_zp_1_1 -> "G_wmc_a_1_wm_1_zp_1_1"
      | G_wmc_wmc_wm_1_wm_1 -> "G_wmc_wmc_wm_1_wm_1"
      | G_wmc_wm_1_z_1_z_1 -> "G_wmc_wm_1_z_1_z_1"
      | G_wmc_wm_1_z_1_zp_1 -> "G_wmc_wm_1_z_1_zp_1"
      | G_wmc_wm_1_z_1_zp_1_1 -> "G_wmc_wm_1_z_1_zp_1_1"
      | G_wmc_wm_1_zp_1_zp_1 -> "G_wmc_wm_1_zp_1_zp_1"

   (* Vertices and fusions *)

   let max_degree () = 4

   let vertices_3 = [
      (FRS (S1_H H1), FRS (S1_H H1), FRS (S1_H H1)),
       Scalar_Scalar_Scalar 1,
       G_h1_h1_h1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h1_h1_h2
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h1_h2_h2
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h2_h2_h2
      ;
      (FRS (S1_H H1), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar_Vector_Vector 1,
       G_h1_a_1_a_1
      ;
      (FRS (S1_H H2), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar_Vector_Vector 1,
       G_h2_a_1_a_1
      ;
      (FRS (S1_H H1), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h1_a_1_z_1
      ;
      (FRS (S1_H H2), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h2_a_1_z_1
      ;
      (FRS (S1_H H1), FRV (V1_A A_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h1_a_1_zp_1
      ;
      (FRS (S1_H H2), FRV (V1_A A_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h2_a_1_zp_1
      ;
      (FRS (S1_H H1), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar_Vector_Vector 1,
       G_h1_wmc_wm_1
      ;
      (FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar_Vector_Vector 1,
       G_h2_wmc_wm_1
      ;
      (FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h1_z_1_z_1
      ;
      (FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h2_z_1_z_1
      ;
      (FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h1_z_1_zp_1
      ;
      (FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h2_z_1_zp_1
      ;
      (FRS (S1_H H1), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h1_zp_1_zp_1
      ;
      (FRS (S1_H H2), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Scalar_Vector_Vector 1,
       G_h2_zp_1_zp_1
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d1
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d1
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d2
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d2
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d3
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d3
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d1
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d1
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d2
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d2
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d3
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d3
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d1
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d1
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d2
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d2
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d3
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d3
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e1
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e1
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e2
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e2
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e3
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e3
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e1
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e1
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e2
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e2
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e3
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e3
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e1
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e1
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e2
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e2
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e3
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e3
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u1
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u1
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u2
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u2
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u3
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u3
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u1
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u1
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u2
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u2
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u3
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u3
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u1
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u1
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u2
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u2
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u3
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u3
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu1
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu1
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu2
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu2
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu3
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu3
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu4
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu4
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu5
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu5
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h1_nu6
      ;
      (FRF (F1_Nu Nu1), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu1_h2_nu6
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h1_nu2
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H2), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h2_nu2
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h1_nu3
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h2_nu3
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h1_nu4
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H2), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h2_nu4
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h1_nu5
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H2), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h2_nu5
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h1_nu6
      ;
      (FRF (F1_Nu Nu2), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu2_h2_nu6
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h1_nu3
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h2_nu3
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h1_nu4
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H2), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h2_nu4
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h1_nu5
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H2), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h2_nu5
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h1_nu6
      ;
      (FRF (F1_Nu Nu3), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu3_h2_nu6
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h1_nu4
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H2), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h2_nu4
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h1_nu5
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H2), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h2_nu5
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h1_nu6
      ;
      (FRF (F1_Nu Nu4), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu4_h2_nu6
      ;
      (FRF (F1_Nu Nu5), FRS (S1_H H1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu5_h1_nu5
      ;
      (FRF (F1_Nu Nu5), FRS (S1_H H2), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu5_h2_nu5
      ;
      (FRF (F1_Nu Nu5), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu5_h1_nu6
      ;
      (FRF (F1_Nu Nu5), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu5_h2_nu6
      ;
      (FRF (F1_Nu Nu6), FRS (S1_H H1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu6_h1_nu6
      ;
      (FRF (F1_Nu Nu6), FRS (S1_H H2), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_nu6_h2_nu6
      ;
      (FRF (F4_D D1bar), FRV (V1_A A_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V1_A A_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V1_A A_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D1bar), FRV (V2_Z Z_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V2_Z Z_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V2_Z Z_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F4_D D1bar), FRV (V10_Zp Zp_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_zp_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V10_Zp Zp_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_zp_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V10_Zp Zp_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_zp_1_d1
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u1bar_wmc_d1
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u1bar_wmc_d2
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u1bar_wmc_d3
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u2bar_wmc_d1
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u2bar_wmc_d2
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u2bar_wmc_d3
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u3bar_wmc_d1
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u3bar_wmc_d2
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u3bar_wmc_d3
      ;
      (FRF (F1_Nu Nu1), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu1_wmc_e1
      ;
      (FRF (F1_Nu Nu1), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu1_wmc_e2
      ;
      (FRF (F1_Nu Nu1), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu1_wmc_e3
      ;
      (FRF (F1_Nu Nu2), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu2_wmc_e1
      ;
      (FRF (F1_Nu Nu2), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu2_wmc_e2
      ;
      (FRF (F1_Nu Nu2), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu2_wmc_e3
      ;
      (FRF (F1_Nu Nu3), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu3_wmc_e1
      ;
      (FRF (F1_Nu Nu3), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu3_wmc_e2
      ;
      (FRF (F1_Nu Nu3), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu3_wmc_e3
      ;
      (FRF (F1_Nu Nu4), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu4_wmc_e1
      ;
      (FRF (F1_Nu Nu4), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu4_wmc_e2
      ;
      (FRF (F1_Nu Nu4), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu4_wmc_e3
      ;
      (FRF (F1_Nu Nu5), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu5_wmc_e1
      ;
      (FRF (F1_Nu Nu5), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu5_wmc_e2
      ;
      (FRF (F1_Nu Nu5), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu5_wmc_e3
      ;
      (FRF (F1_Nu Nu6), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu6_wmc_e1
      ;
      (FRF (F1_Nu Nu6), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu6_wmc_e2
      ;
      (FRF (F1_Nu Nu6), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VL, Coupling.Psi),
       G_nu6_wmc_e3
      ;
      (FRF (F2_E E1bar), FRV (V1_A A_1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E2bar), FRV (V1_A A_1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E3bar), FRV (V1_A A_1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E1bar), FRV (V2_Z Z_1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F2_E E2bar), FRV (V2_Z Z_1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F2_E E3bar), FRV (V2_Z Z_1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F2_E E1bar), FRV (V10_Zp Zp_1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_zp_1_e1
      ;
      (FRF (F2_E E2bar), FRV (V10_Zp Zp_1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_zp_1_e1
      ;
      (FRF (F2_E E3bar), FRV (V10_Zp Zp_1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_zp_1_e1
      ;
      (FRF (F3_U U1bar), FRV (V1_A A_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F3_U U2bar), FRV (V1_A A_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F3_U U3bar), FRV (V1_A A_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d1bar_wm_1_u1
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d1bar_wm_1_u2
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d1bar_wm_1_u3
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d2bar_wm_1_u1
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d2bar_wm_1_u2
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d2bar_wm_1_u3
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d3bar_wm_1_u1
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d3bar_wm_1_u2
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d3bar_wm_1_u3
      ;
      (FRF (F3_U U1bar), FRV (V2_Z Z_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F3_U U2bar), FRV (V2_Z Z_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F3_U U3bar), FRV (V2_Z Z_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F3_U U1bar), FRV (V10_Zp Zp_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_zp_1_u1
      ;
      (FRF (F3_U U2bar), FRV (V10_Zp Zp_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_zp_1_u1
      ;
      (FRF (F3_U U3bar), FRV (V10_Zp Zp_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_zp_1_u1
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu1
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu2
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu3
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu4
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu5
      ;
      (FRF (F1_Nu Nu1), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_a_1_nu6
      ;
      (FRF (F1_Nu Nu2), FRV (V1_A A_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_a_1_nu2
      ;
      (FRF (F1_Nu Nu2), FRV (V1_A A_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_a_1_nu3
      ;
      (FRF (F1_Nu Nu2), FRV (V1_A A_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_a_1_nu4
      ;
      (FRF (F1_Nu Nu2), FRV (V1_A A_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_a_1_nu5
      ;
      (FRF (F1_Nu Nu2), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_a_1_nu6
      ;
      (FRF (F1_Nu Nu3), FRV (V1_A A_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_a_1_nu3
      ;
      (FRF (F1_Nu Nu3), FRV (V1_A A_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_a_1_nu4
      ;
      (FRF (F1_Nu Nu3), FRV (V1_A A_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_a_1_nu5
      ;
      (FRF (F1_Nu Nu3), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_a_1_nu6
      ;
      (FRF (F1_Nu Nu4), FRV (V1_A A_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_a_1_nu4
      ;
      (FRF (F1_Nu Nu4), FRV (V1_A A_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_a_1_nu5
      ;
      (FRF (F1_Nu Nu4), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_a_1_nu6
      ;
      (FRF (F1_Nu Nu5), FRV (V1_A A_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_a_1_nu5
      ;
      (FRF (F1_Nu Nu5), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_a_1_nu6
      ;
      (FRF (F1_Nu Nu6), FRV (V1_A A_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu6_a_1_nu6
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu1
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu2
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu3
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu4
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu5
      ;
      (FRF (F1_Nu Nu1), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_z_1_nu6
      ;
      (FRF (F1_Nu Nu2), FRV (V2_Z Z_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_z_1_nu2
      ;
      (FRF (F1_Nu Nu2), FRV (V2_Z Z_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_z_1_nu3
      ;
      (FRF (F1_Nu Nu2), FRV (V2_Z Z_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_z_1_nu4
      ;
      (FRF (F1_Nu Nu2), FRV (V2_Z Z_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_z_1_nu5
      ;
      (FRF (F1_Nu Nu2), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_z_1_nu6
      ;
      (FRF (F1_Nu Nu3), FRV (V2_Z Z_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_z_1_nu3
      ;
      (FRF (F1_Nu Nu3), FRV (V2_Z Z_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_z_1_nu4
      ;
      (FRF (F1_Nu Nu3), FRV (V2_Z Z_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_z_1_nu5
      ;
      (FRF (F1_Nu Nu3), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_z_1_nu6
      ;
      (FRF (F1_Nu Nu4), FRV (V2_Z Z_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_z_1_nu4
      ;
      (FRF (F1_Nu Nu4), FRV (V2_Z Z_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_z_1_nu5
      ;
      (FRF (F1_Nu Nu4), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_z_1_nu6
      ;
      (FRF (F1_Nu Nu5), FRV (V2_Z Z_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_z_1_nu5
      ;
      (FRF (F1_Nu Nu5), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_z_1_nu6
      ;
      (FRF (F1_Nu Nu6), FRV (V2_Z Z_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu6_z_1_nu6
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu1
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu2
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu3
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu4
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu5
      ;
      (FRF (F1_Nu Nu1), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu1_zp_1_nu6
      ;
      (FRF (F1_Nu Nu2), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_zp_1_nu2
      ;
      (FRF (F1_Nu Nu2), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_zp_1_nu3
      ;
      (FRF (F1_Nu Nu2), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_zp_1_nu4
      ;
      (FRF (F1_Nu Nu2), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_zp_1_nu5
      ;
      (FRF (F1_Nu Nu2), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu2_zp_1_nu6
      ;
      (FRF (F1_Nu Nu3), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_zp_1_nu3
      ;
      (FRF (F1_Nu Nu3), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_zp_1_nu4
      ;
      (FRF (F1_Nu Nu3), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_zp_1_nu5
      ;
      (FRF (F1_Nu Nu3), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu3_zp_1_nu6
      ;
      (FRF (F1_Nu Nu4), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_zp_1_nu4
      ;
      (FRF (F1_Nu Nu4), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_zp_1_nu5
      ;
      (FRF (F1_Nu Nu4), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu4_zp_1_nu6
      ;
      (FRF (F1_Nu Nu5), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_zp_1_nu5
      ;
      (FRF (F1_Nu Nu5), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu5_zp_1_nu6
      ;
      (FRF (F1_Nu Nu6), FRV (V10_Zp Zp_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_nu6_zp_1_nu6
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu1
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu2
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu3
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu4
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu5
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e1bar_wm_1_nu6
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu1
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu2
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu3
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu4
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu5
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e2bar_wm_1_nu6
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu1
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu2
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu3
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu4
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu5)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu5
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu6)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Chi),
       G_e3bar_wm_1_nu6
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Gauge_Gauge_Gauge 1,
       G_wmc_a_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Gauge_Gauge_Gauge 1,
       G_wmc_wm_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V10_Zp Zp_1)),
       Gauge_Gauge_Gauge 1,
       G_wmc_wm_1_zp_1
   ]

   let vertices_3_qcd = [
      (FRF (F4_D D1bar), FRV (V5_G G_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V5_G G_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V5_G G_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U1bar), FRV (V5_G G_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U2bar), FRV (V5_G G_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U3bar), FRV (V5_G G_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1)),
       Gauge_Gauge_Gauge 1,
       G_g_1_g_1_g_1
   ]

   let vertices_4 = [
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h1_h1_a_1_a_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h1_h2_a_1_a_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h2_h2_a_1_a_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h1_a_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h2_a_1_z_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h2_h2_a_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V1_A A_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h1_a_1_zp_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V1_A A_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h2_a_1_zp_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V1_A A_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h2_h2_a_1_zp_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h1_h1_wmc_wm_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h1_h2_wmc_wm_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h2_h2_wmc_wm_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h1_z_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h2_z_1_z_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h2_h2_z_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h1_z_1_zp_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h2_z_1_zp_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h2_h2_z_1_zp_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h1_zp_1_zp_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h1_h2_zp_1_zp_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Scalar2_Vector2 1,
       G_h2_h2_zp_1_zp_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Vector4 [1, Coupling.C_12_34; 1, Coupling.C_13_42; -2, Coupling.C_14_23],
       G_wmc_a_1_a_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_12_34],
       G_wmc_a_1_wm_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_13_42],
       G_wmc_a_1_wm_1_z_1_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_14_23],
       G_wmc_a_1_wm_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_12_34],
       G_wmc_a_1_wm_1_zp_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_13_42],
       G_wmc_a_1_wm_1_zp_1_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_14_23],
       G_wmc_a_1_wm_1_zp_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V3_Wm Wm_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_wmc_wmc_wm_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_wmc_wm_1_z_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_12_34],
       G_wmc_wm_1_z_1_zp_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_13_42],
       G_wmc_wm_1_z_1_zp_1_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1), FRV (V10_Zp Zp_1)),
       Vector4 [1, Coupling.C_14_23],
       G_wmc_wm_1_z_1_zp_1_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V10_Zp Zp_1), FRV (V10_Zp Zp_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_wmc_wm_1_zp_1_zp_1
   ]

   let vertices_4_qcd = [
      (FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1)),
       Vector4 [1, Coupling.C_12_34; -2, Coupling.C_13_42; 1, Coupling.C_14_23],
       G_g_1_g_1_g_1_g_1
   ]

   let vertices_n = []

   let vertices_n_qcd = []

   let vertices () = (
      vertices_3 @ (match Opts.color with true -> vertices_3_qcd | false -> []),
      vertices_4 @ (match Opts.color with true -> vertices_4_qcd | false -> []),
      vertices_n @ (match Opts.color with true -> vertices_n_qcd | false -> [])
   )

   module F = Modeltools.Fusions (struct
      type f = flavor
      type c = constant
      let compare = compare
      let conjugate = conjugate
   end)

   let table = F.of_vertices (vertices ())
   let fuse2 = F.fuse2 table
   let fuse3 = F.fuse3 table
   let fuse = F.fuse table

   (* Charge (stubbed) *)

   module Ch = Charges.Null
   let charges _ = ()

   (* Misc. infrastructure *)

   let options = Options.empty

   let rcs = RCS.parse "blsm_sarah" ["automatically generated model"] {
      RCS.revision = "Revision: Noop";
      RCS.date = "Date: Noop";
      RCS.author = "Author: Mathematica automaton";
      RCS.source = "Source: Noop"
   }

   type flavor_sans_color = flavor
   let flavor_sans_color x = x
   let conjugate_sans_color = conjugate
   let flavor_sans_color_of_string = flavor_of_string
   let flavor_sans_color_to_string = flavor_to_string
   let flavor_sans_color_to_TeX = flavor_to_TeX
   let flavor_sans_color_symbol = flavor_symbol

end
